SystemOrganization addCategory: #'Synthesis-Filters'!
SystemOrganization addCategory: #'Synthesis-Info'!
SystemOrganization addCategory: #'Synthesis-Instruments'!
SystemOrganization addCategory: #'Synthesis-Sources'!


Object subclass: #Filter
	instanceVariableNames: 'lastOutput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Filters'!

Object subclass: #JetTable
	instanceVariableNames: 'lastOutput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Sources'!

Filter subclass: #TwoZero
	instanceVariableNames: 'gain z0 z1 inputs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Filters'!

Filter subclass: #DLineA
	instanceVariableNames: 'inPoint outPoint length inputs alpha coefficient lastIn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Filters'!

Filter subclass: #DLineN
	instanceVariableNames: 'inPoint outPoint length inputs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Filters'!

Object subclass: #Envelope2
	instanceVariableNames: 'target value rate state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Sources'!

Filter subclass: #BiQuad
	instanceVariableNames: 'gain p0 p1 z0 z1 inputs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Filters'!

Envelope2 subclass: #ADSR
	instanceVariableNames: 'attackRate decayRate sustainLevel releaseRate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Sources'!

JetTable class
	instanceVariableNames: ''!

Filter subclass: #DCBlock
	instanceVariableNames: 'input'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Filters'!

Filter subclass: #Amp
	instanceVariableNames: 'input gain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Filters'!

Filter subclass: #OnePole
	instanceVariableNames: 'gain coefficient sgain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Filters'!

Object subclass: #BowTable
	instanceVariableNames: 'offset slope lastOutput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Sources'!

BowTable class
	instanceVariableNames: ''!

Object subclass: #LipFilter
	instanceVariableNames: 'filter lastOutput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Sources'!

Filter subclass: #OneZero
	instanceVariableNames: 'gain coefficient sgain input'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Filters'!

Filter class
	instanceVariableNames: ''!

Amp class
	instanceVariableNames: ''!

BiQuad class
	instanceVariableNames: ''!

DCBlock class
	instanceVariableNames: ''!

OneZero class
	instanceVariableNames: ''!

TwoZero class
	instanceVariableNames: ''!

OnePole class
	instanceVariableNames: ''!

Envelope2 class
	instanceVariableNames: ''!

Filter subclass: #DLineL
	instanceVariableNames: 'inPoint outPoint length alpha inputs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Filters'!

DLineL class
	instanceVariableNames: ''!

PackageInfo subclass: #SynthesisInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Info'!

DLineN class
	instanceVariableNames: ''!

Object subclass: #WvIn
	instanceVariableNames: 'length channels looping finished interpolate data time rate phaseOffset lastOutput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Sources'!

WvIn subclass: #MonoWvIn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Sources'!

WvIn class
	instanceVariableNames: ''!

MonoWvIn class
	instanceVariableNames: ''!

Object subclass: #Instrument
	instanceVariableNames: 'lastOutput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

Instrument subclass: #Drone
	instanceVariableNames: 'delayLine loopFilter envelope noise loopGain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

Instrument subclass: #Brass
	instanceVariableNames: 'delayLine lipFilter dcBlock adsr vibr lipTarget slideTarget vibrGain maxPressure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

Instrument subclass: #Sitar
	instanceVariableNames: 'delayLine loopFilter envelope noise loopGain amPluck delay delayTarget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

Instrument class
	instanceVariableNames: ''!

Instrument subclass: #Modal4
	instanceVariableNames: 'envelope wave filters onepole vibr vibrGain masterGain directGain stickHardness strikePosition frequency ratios resonances'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

Modal4 subclass: #AgogoBell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

Brass class
	instanceVariableNames: ''!

Modal4 subclass: #Marimba
	instanceVariableNames: 'multiStrike'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

Modal4 class
	instanceVariableNames: ''!

AgogoBell class
	instanceVariableNames: ''!

Instrument subclass: #BowedString
	instanceVariableNames: 'neckDelay bridgeDelay bowTable reflFilt bodyFilt vibr adsr maxVelocity baseDelay vibrGain betaRatio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

BowedString class
	instanceVariableNames: ''!

Instrument subclass: #FM4Op
	instanceVariableNames: 'adsr waves vibWave twozero frequency ratios gains modulationDepth control1 control2'
	classVariableNames: 'AttackTimes Gains SustainLevels'
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

FM4Op class
	instanceVariableNames: ''!

FM4Op subclass: #FM4Alg8
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

FM4Op subclass: #FM4Alg5
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

FM4Alg5 class
	instanceVariableNames: ''!

FM4Alg5 subclass: #Wurley
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

Wurley class
	instanceVariableNames: ''!

FM4Alg8 class
	instanceVariableNames: ''!

FM4Alg5 subclass: #Rhodey
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

Rhodey class
	instanceVariableNames: ''!

FM4Alg5 subclass: #TubularBell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

Marimba class
	instanceVariableNames: ''!

Object subclass: #ReedTable
	instanceVariableNames: 'offset slope lastOutput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Sources'!

ReedTable class
	instanceVariableNames: ''!

Instrument subclass: #PluckedString
	instanceVariableNames: 'delayLine delayLine2 combDelay filter filter2 length loopGain baseLoopGain lastFrequency lastLength detuning pluckAmplitude pluckPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

PluckedString class
	instanceVariableNames: ''!

PluckedString subclass: #Mandolin
	instanceVariableNames: 'waves mic dampTime waveDone'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

Mandolin class
	instanceVariableNames: ''!

DLineA class
	instanceVariableNames: ''!

TubularBell class
	instanceVariableNames: ''!

Modal4 subclass: #Vibraphone
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

Vibraphone class
	instanceVariableNames: ''!

ADSR class
	instanceVariableNames: ''!

SynthesisInfo class
	instanceVariableNames: ''!

Object subclass: #Noise
	instanceVariableNames: 'seed lastOutput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Sources'!

Noise class
	instanceVariableNames: ''!

Noise subclass: #SubNoise
	instanceVariableNames: 'howOften counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Sources'!

SubNoise class
	instanceVariableNames: ''!

Drone class
	instanceVariableNames: ''!

Sitar class
	instanceVariableNames: ''!

Instrument subclass: #Clarinet
	instanceVariableNames: 'delayLine reedTable filter envelope noise vibr outputGain noiseGain vibrGain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

Clarinet class
	instanceVariableNames: ''!

FM4Alg8 subclass: #BeeThree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

BeeThree class
	instanceVariableNames: ''!

Filter subclass: #TwoPole
	instanceVariableNames: 'gain p0 p1 outputs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Filters'!

TwoPole class
	instanceVariableNames: ''!

LipFilter class
	instanceVariableNames: ''!

Instrument subclass: #Flute
	instanceVariableNames: 'jetDelay boreDelay jetTable filter dcBlock noise adsr vibr lastFrequency maxPressure jetReflection endReflection noiseGain vibrGain outputGain jetRatio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Synthesis-Instruments'!

Flute class
	instanceVariableNames: ''!


!BeeThree commentStamp: '<historical>' prior: 0!
Hammond-like Organ subclass of Algorithm 8 (TX81Z), subclass of the Four Operator FM Synthesizer.!
]style[(97)!

!BowedString commentStamp: '<historical>' prior: 0!
Bowed String physical model ala Smith after McIntyre, Schumacher, Woodhouse.

This is a waveguide model, and thus relates to various Stanford Univ. and possibly Yamaha and other patents.!
]style[(186)!

!Brass commentStamp: '<historical>' prior: 0!
Waveguide Brass instrument model ala Cook (TBone, HosePlayer).

This is a waveguide model, and thus relates to various Stanford Univ. and possibly Yamaha and other patents.!
]style[(172)!

!Clarinet commentStamp: '<historical>' prior: 0!
Clarinet physical model ala Smith after McIntyre, Schumacher, Woodhouse.

This is a waveguide model, and thus relates to various Stanford Univ. and possibly Yamaha and other patents.!
]style[(182)!

!DLineA commentStamp: '<historical>' prior: 0!
AllPass Interpolating Delay Line.

This one uses a delay line of maximum length specified on creation, and interpolates fractional length using an all-pass filter.  This version is more efficient for computing static length delay lines (alpha and coeff are computed only when the length is set, there probably is a more efficient computational form if alpha is changed often (each sample)).!
]style[(390)!

!DLineL commentStamp: '<historical>' prior: 0!
Linearly Interpolating Delay Line.

This one uses a delay line of maximum length specified on creation, and linearly interpolates fractional length.  It is designed to be more efficient if the delay length is not changed very often. !
]style[(233)!

!DLineN commentStamp: '<historical>' prior: 0!
Non-Interpolating Delay Line.

This one uses a delay line of maximum length specified on creation.  A non-interpolating delay line should be used in non-time varying (reverb) or non-critical (????) applications.!
]style[(211)!

!Drone commentStamp: '<historical>' prior: 0!
Karplus-Strong Drone physical model.

There exist at least two patens, assigned to Stanford, bearing the names of Karplus and/or Strong.!
]style[(136)!

!FM4Alg5 commentStamp: '<historical>' prior: 0!
Algorithm 5 (TX81Z) subclass of the Four Operator FM Synthesizer. This connection topology is 2 simple FM Pairs summed together, like:

		1 -> 2 -\
				+-> Out
		3 -> 4 -/!
]style[(171)!

!FM4Alg8 commentStamp: '<historical>' prior: 0!
Algorithm 8 (TX81Z) subclass of the Four Operator FM Synthesizer. This connection topology is simple Additive Synthesis, like:

		1 ---.
		2 -\ |
			+-> Out
		3 -/ |
		4 ---!
]style[(173)!

!FM4Op commentStamp: '<historical>' prior: 0!
Abstract class for Four Operator FM Synthesizers. This instrument contains 4 waves, 4 ADSR, and various state vars.

The basic Chowning/Stanford FM patent expired April 1995, but there exist follow-on patents, mostly assigned to Yamaha. If you are of the type who should worry about this (making money) worry away.!
]style[(314)!

!Flute commentStamp: '<historical>' prior: 0!
Waveguide Flute ala Karjalainen, Smith, Waryznyk, etc. with polynomial Jet ala Cook.

This is a waveguide model, and thus relates to various Stanford Univ. and possibly Yamaha and other patents.!
]style[(194)!

!LipFilter commentStamp: '<historical>' prior: 0!
The lip of the brass player has dynamics which are controlled by the mass, spring constant, and damping of the lip. This filter simulates that behavior and the transmission/reflection properties as well. See Cook TBone and HosePlayer instruments and articles.!
]style[(259)!

!Mandolin commentStamp: '<historical>' prior: 0!
Commuted Mandolin subclass of enhanced dual plucked-string model.

Note: Commuted Synthesis, as with many other WaveGuide techniques, is covered by patents, granted, pending, and/or applied-for.  All are assigned to the Board of Trustees, Stanford University. For information, contact the Office of Technology Licensing, Stanford U.!
]style[(332)!

!Modal4 commentStamp: '<historical>' prior: 0!
Four Resonance Modal Synthesis Instrument.

This instrument contains an excitation wavetable, an envelope, and four resonances (Non-Sweeping BiQuad Filters).!
]style[(157)!

!PluckedString commentStamp: '<historical>' prior: 0!
Enhanced (Jaffe-Smith, Smith, others) Karplus-Strong plucked model.

This is an abstract class, with no excitation specified. So this one by itself doesn't make any sound.!
]style[(171)!

!Rhodey commentStamp: '<historical>' prior: 0!
Fender Rhodes Electric Piano subclass of Algorithm 5 (TX81Z) subclass of the Four Operator FM Synthesizer.!
]style[(106)!

!Sitar commentStamp: '<historical>' prior: 0!
Karplus-Strong Sitar physical model.

There exist at least two patents, assigned to Stanford, bearing the names of Karplus and/or Strong.!
]style[(137)!

!TubularBell commentStamp: '<historical>' prior: 0!
Tubular Bell (Orch. Chime) Subclass of Algorithm 5 (TX81Z) subclass of the Four Operator FM Synthesizer.!
]style[(104)!

!Wurley commentStamp: '<historical>' prior: 0!
Wurlitzer Electric Piano subclass of Algorithm 5 (TX81Z) subclass of Four Operator FM Synthesizer.!
]style[(98)!

!WvIn methodsFor: 'accessing' stamp: 'len 8/27/2000 01:18'!
addPhase: angle
	"Add time in cycles. Cycles here means 1.0 = length."
	self addTime: length * angle asFloat fractionPart! !

!WvIn methodsFor: 'accessing' stamp: 'len 8/27/2000 01:19'!
addPhaseOffset: angle
	"Add a phase offset in cycles, where 1.0 = length."
	phaseOffset := length * angle asFloat fractionPart! !

!WvIn methodsFor: 'accessing' stamp: 'len 5/28/2000 20:49'!
addTime: aNumber
	"Add absolute time in samples."
	time := time + aNumber! !

!SynthesisInfo methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:17'!
additionalFiles
	^
	#(
		'ahh.raw'
		'bassdrum.raw'
		'britestk.raw'
		'fwavblnk.raw'
		'mand1.raw'
		'mand2.raw'
		'mand3.raw'
		'mand4.raw'
		'mand5.raw'
		'mand6.raw'
		'mand7.raw'
		'mand8.raw'
		'mand9.raw'
		'mand10.raw'
		'mand11.raw'
		'mand12.raw'
		) collect: [:fn | 'rawwaves' , FileDirectory slash, fn]! !

!WvIn class methodsFor: 'examples' stamp: 'spfa 11/18/2009 18:17'!
ahh
	"
	(WvIn ahh asSampledSoundCount: 10000) play
	"
	^ MonoWvIn loopFromFileNamed: 'rawwaves', FileDirectory slash,'ahh.raw'! !

!WvIn methodsFor: 'generation' stamp: 'len 5/28/2000 22:34'!
asSampledSound
	^ self asSampledSoundCount: length! !

!WvIn methodsFor: 'generation' stamp: 'len 6/3/2000 18:14'!
asSampledSoundCount2: n
	"
	WvIn sinewave asSampledSoundCount2: 50000
	"
	| samples |
	samples := SoundBuffer new: n.
	1 to: n do: [ :i | samples at: i put: self tick truncated].
	^ LoopedSampledSound unloopedSamples: samples pitch: self frequency samplingRate: self samplingRate! !

!MonoWvIn methodsFor: 'accessing' stamp: 'len 8/27/2000 01:29'!
at: index channel: channel
	^ data at: index! !

!WvIn methodsFor: 'accessing' stamp: 'len 5/28/2000 21:58'!
at: index channel: channel
	^ data at: index - 1 * channels + channel! !

!MonoWvIn methodsFor: 'accessing' stamp: 'len 8/27/2000 01:28'!
at: index channel: channel put: anObject
	^ data at: index put: anObject! !

!WvIn methodsFor: 'accessing' stamp: 'len 5/28/2000 21:57'!
at: index channel: channel put: anObject
	^ data at: index - 1 * channels + channel put: anObject! !

!ADSR methodsFor: 'accessing' stamp: 'len 5/29/2000 05:19'!
attackRate: aNumber
	attackRate := aNumber abs! !

!ADSR methodsFor: 'private' stamp: 'len 5/28/2000 06:06'!
attackState
	^ 0! !

!ADSR methodsFor: 'generation-private' stamp: 'len 6/3/2000 21:14'!
attackTick
	value := value + rate.
	value >= target
		ifTrue: [value := target.
				rate := decayRate.
				target := sustainLevel.
				state := self decayState].
	^ value! !

!ADSR methodsFor: 'accessing' stamp: 'len 5/29/2000 02:32'!
attackTime: aNumber
	self attackRate: 1.0 / self samplingRate / aNumber! !

!PluckedString methodsFor: 'accessing' stamp: 'len 6/3/2000 23:45'!
baseLoopGain: aNumber
	baseLoopGain := aNumber.
	loopGain := lastFrequency * 0.000005 + baseLoopGain.
	loopGain > 1.0 ifTrue: [loopGain := 0.99999]! !

!WvIn class methodsFor: 'examples' stamp: 'spfa 11/18/2009 18:17'!
bassdrum
	"
	(WvIn bassdrum asSampledSoundCount: 10000) play
	"
	^ MonoWvIn loopFromFileNamed: 'rawwaves', FileDirectory slash,'bassdrum.raw'! !

!Mandolin methodsFor: 'accessing' stamp: 'len 6/4/2000 00:15'!
bodySize: aNumber
	waves do: [ :each | each rate: aNumber]! !

!BowedString methodsFor: 'accessing' stamp: 'len 5/29/2000 20:49'!
bowPosition: aNumber
	betaRatio := 0.027236 + (0.2 * aNumber).
	bridgeDelay delay: baseDelay * betaRatio. "bow to bridge length"
	neckDelay delay: baseDelay * (1.0 - betaRatio) "bow to nut (finger) delay"! !

!BowedString methodsFor: 'accessing' stamp: 'len 5/29/2000 20:48'!
bowPressure: aNumber
	bowTable slope: 5.0 - (4.0 * aNumber)! !

!WvIn class methodsFor: 'examples' stamp: 'spfa 11/18/2009 18:17'!
britestk
	"
	WvIn britestk asSampledSound play
	"
	^ MonoWvIn oneshotFromFileNamed: 'rawwaves', FileDirectory slash,'britestk.raw'! !

!Instrument methodsFor: 'examples-scales' stamp: 'len 9/2/2000 22:09'!
chromaticScale
	"
	Marimba new chromaticScale play
	Vibraphone new chromaticScale play
	AgogoBell new chromaticScale play
	BeeThree new chromaticScale play
	"
	^ AbstractSound chromaticScaleOn: self! !

!Amp methodsFor: 'as yet unclassified' stamp: 'spfa 1/18/2022 15:32'!
clear
	input := lastOutput := 0.0! !

!BiQuad methodsFor: 'generation' stamp: 'len 5/28/2000 03:26'!
clear
	inputs atAllPut: 0.0.
	lastOutput := 0.0! !

!BowedString methodsFor: 'generation' stamp: 'len 5/29/2000 05:04'!
clear
	neckDelay clear.
	bridgeDelay clear! !

!Brass methodsFor: 'generation' stamp: 'len 5/29/2000 20:33'!
clear
	delayLine clear.
	lipFilter clear.
	dcBlock clear! !

!Clarinet methodsFor: 'generation' stamp: 'len 5/29/2000 18:56'!
clear
	delayLine clear.
	filter tick: 0.0! !

!DCBlock methodsFor: 'generation' stamp: 'len 6/3/2000 21:21'!
clear
	input := lastOutput := 0.0! !

!DLineA methodsFor: 'generation' stamp: 'len 6/4/2000 01:01'!
clear
	inputs atAllPut: 0.0.
	lastIn := lastOutput := 0.0! !

!DLineL methodsFor: 'generation' stamp: 'len 5/29/2000 04:41'!
clear
	inputs atAllPut: 0.0.
	lastOutput := 0.0! !

!DLineN methodsFor: 'generation' stamp: 'len 5/28/2000 03:47'!
clear
	inputs atAllPut: 0.0.
	lastOutput := 0.0! !

!Drone methodsFor: 'generation' stamp: 'len 9/3/2000 03:09'!
clear
	loopFilter clear.
	delayLine clear! !

!Flute methodsFor: 'generation' stamp: 'len 5/29/2000 19:37'!
clear
	jetDelay clear.
	boreDelay clear.
	filter clear.
	dcBlock clear! !

!LipFilter methodsFor: 'generation' stamp: 'len 5/28/2000 05:29'!
clear
	filter clear.
	lastOutput := 0.0! !

!Modal4 methodsFor: 'generation' stamp: 'len 5/28/2000 23:27'!
clear
	onepole clear.
	filters do: [ :each | each clear]! !

!OnePole methodsFor: 'generation' stamp: 'len 6/3/2000 21:03'!
clear
	lastOutput := 0.0! !

!OneZero methodsFor: 'generation' stamp: 'len 5/28/2000 16:16'!
clear
	input := lastOutput := 0.0! !

!PluckedString methodsFor: 'generation' stamp: 'len 6/3/2000 21:38'!
clear
	delayLine clear.
	delayLine2 clear.
	combDelay clear.
	filter clear.
	filter2 clear! !

!Sitar methodsFor: 'generation' stamp: 'len 9/3/2000 02:49'!
clear
	loopFilter clear.
	delayLine clear! !

!TwoPole methodsFor: 'generation' stamp: 'len 5/28/2000 05:10'!
clear
	outputs atAllPut: 0.0.
	lastOutput := 0.0! !

!TwoZero methodsFor: 'generation' stamp: 'len 5/28/2000 05:18'!
clear
	inputs atAllPut: 0.0.
	lastOutput := 0.0! !

!OnePole methodsFor: 'accessing' stamp: 'len 6/3/2000 20:27'!
coefficient: aNumber
	coefficient := aNumber.
	self normalizeGain! !

!OneZero methodsFor: 'accessing' stamp: 'len 6/3/2000 20:21'!
coefficient: aNumber
	coefficient := aNumber.
	self normalizeGain! !

!TwoPole methodsFor: 'accessing' stamp: 'len 5/28/2000 05:11'!
coefficients: aCollection
	p0 := aCollection first.
	p1 := aCollection second! !

!TwoZero methodsFor: 'accessing' stamp: 'len 5/28/2000 05:19'!
coefficients: aCollection
	z0 := aCollection first.
	z1 := aCollection second! !

!FM4Op methodsFor: 'accessing' stamp: 'len 8/26/2000 22:24'!
control1: aNumber
	control1 := aNumber! !

!FM4Op methodsFor: 'accessing' stamp: 'len 8/26/2000 22:24'!
control2: aNumber
	control2 := aNumber! !

!AgogoBell methodsFor: 'events' stamp: 'len 9/2/2000 17:03'!
controlChange: control value: value
	control == #StickHardness ifTrue: [^ self stickHardness: value / 127.0].
	control == #StrikePosition ifTrue: [^ self strikePosition: value / 127.0].
	control == #ModFrequency ifTrue: [^ vibr frequency: value / 127.0 * 12.0].
	control == #ModWheel ifTrue: [^ vibrGain := value / 127.0].
	control == #AfterTouchCont ifTrue: [^ self strike: value / 127.0].
	self errorUndefinedControl: control! !

!BowedString methodsFor: 'events' stamp: 'len 9/2/2000 17:03'!
controlChange: control value: value
	control == #BowPressure ifTrue: [^ self bowPressure: value / 127.0].
	control == #BowPosition ifTrue: [self bowPosition: value / 127.0].
	control == #ModFrequency ifTrue: [^ vibr frequency: value / 127.0 * 12.0].
	control == #ModWheel ifTrue: [^ vibrGain := 0.4 * value / 127.0].
	control == #AfterTouchCont ifTrue: [^ adsr target: value / 127.0].
	self errorUndefinedControl: control! !

!Brass methodsFor: 'events' stamp: 'len 9/2/2000 17:03'!
controlChange: control value: value
	control == #LipTension ifTrue: [^ self lipTension: value / 127.0].
	control == #SlideLength ifTrue: [^ self slideLength: value / 127.0].
	control == #ModFrequency ifTrue: [^ vibr frequency: value / 127.0 * 12.0].
	control == #ModWheel ifTrue: [^ vibrGain := 0.4 * value / 127.0].
	control == #AfterTouchCont ifTrue: [^ adsr target: value / 127.0].
	self errorUndefinedControl: control! !

!Clarinet methodsFor: 'events' stamp: 'len 9/2/2000 17:03'!
controlChange: control value: value
	control == #ReedStiffness ifTrue: [^ self reedStiffness: value / 127.0].
	control == #NoiseLevel ifTrue: [^ self noiseLevel: value / 127.0].
	control == #ModFrequency ifTrue: [^ vibr frequency: value / 127.0 * 12.0].
	control == #ModWheel ifTrue: [^ vibrGain := 0.5 * value / 127.0].
	control == #AfterTouchCont ifTrue: [^ envelope value: value / 127.0].
	self errorUndefinedControl: control! !

!Drone methodsFor: 'events' stamp: 'len 9/3/2000 03:19'!
controlChange: control value: value
	^ self! !

!FM4Op methodsFor: 'events' stamp: 'len 9/2/2000 17:04'!
controlChange: control value: value
	control == #Breath ifTrue: [^ self control1: value / 127.0].
	control == #FootControl ifTrue: [^ self control2: value / 127.0].
	control == #ModFrequency ifTrue: [^ self modulationSpeed: value / 127.0 * 12.0].
	control == #ModWheel ifTrue: [^ self modulationDepth: value / 127.0].
	control == #AfterTouchCont ifTrue: [adsr second target: value / 127.0. ^ adsr fourth target: value / 127.0].
	self errorUndefinedControl: control! !

!Flute methodsFor: 'events' stamp: 'len 9/2/2000 17:02'!
controlChange: control value: value
	control == #JetDelay ifTrue: [^ self jetDelay: 0.48 * value / 127.0 + 0.08].
	control == #NoiseLevel ifTrue: [^ self noiseLevel: value / 127.0].
	control == #ModFrequency ifTrue: [^ vibr frequency: value / 127.0 * 12.0].
	control == #ModWheel ifTrue: [^ vibrGain := 0.4 * value / 127.0].
	control == #AfterTouchCont ifTrue: [^ adsr target: value / 127.0].
	self errorUndefinedControl: control! !

!Instrument methodsFor: 'events' stamp: 'len 5/30/2000 10:00'!
controlChange: controlSymbol value: value
	self subclassResponsibility! !

!Mandolin methodsFor: 'events' stamp: 'len 9/2/2000 20:28'!
controlChange: control value: value
	control == #BodySize ifTrue: [^ self bodySize: value / 127.0 * 2.0].
	control == #PickPosition ifTrue: [^ self pluckPosition: value / 127.0].
	control == #StringDamping ifTrue: [^ self baseLoopGain: value / 127.0 * 0.03 + 0.97].
	control == #StringDetune ifTrue: [^ self detune: 1.0 - (value / 127.0 * 0.1)].
	control == #AfterTouchCont ifTrue: [^ self strike: value / 127.0].
	control == #StringNumber ifTrue: [^ mic := mic \\ 12 + 1].
	self errorUndefinedControl: control! !

!Marimba methodsFor: 'events' stamp: 'len 9/2/2000 17:04'!
controlChange: control value: value
	control == #StickHardness ifTrue: [^ self stickHardness: value / 127.0].
	control == #StrikePosition ifTrue: [^ self strikePosition: value / 127.0].
	control == #ModFrequency ifTrue: [^ vibr frequency: value / 127.0 * 12.0].
	control == #ModWheel ifTrue: [^ vibrGain := value / 127.0].
	control == #AfterTouchCont ifTrue: [^ self strike: value / 127.0].
	self errorUndefinedControl: control! !

!Modal4 methodsFor: 'events' stamp: 'len 5/28/2000 23:35'!
controlChange: control value: value
	^ self! !

!Sitar methodsFor: 'events' stamp: 'len 9/3/2000 03:00'!
controlChange: control value: value
	^ self! !

!Vibraphone methodsFor: 'events' stamp: 'len 9/2/2000 17:05'!
controlChange: control value: value
	control == #StickHardness ifTrue: [^ self stickHardness: value / 127.0].
	control == #StrikePosition ifTrue: [^ self strikePosition: value / 127.0].
	control == #ModFrequency ifTrue: [^ vibr frequency: value / 127.0 * 12.0].
	control == #ModWheel ifTrue: [^ vibrGain := value / 127.0].
	control == #AfterTouchCont ifTrue: [^ self strike: value / 127.0].
	self errorUndefinedControl: control! !

!Instrument methodsFor: 'accessing' stamp: 'spfa 11/18/2009 18:10'!
controls
	"Answer the list of controls accepted by this instrument."
	^ (self class lookupSelector: #controlChange:value:) literals select: [ :each | each isSymbol and: [each first isUppercase]]! !

!MonoWvIn methodsFor: 'generation-private' stamp: 'len 8/27/2000 02:04'!
currentTime
	| answer |
	answer := time.
	phaseOffset ~= 0.0
		ifTrue: [answer := answer + phaseOffset. "Add phase offset."
				looping
					ifTrue: [[answer >= length] whileTrue: [answer := answer - length].
							[answer < 0.0] whileTrue: [answer := answer + length]]
					ifFalse: [answer >= length ifTrue: [answer := length - 1.0].
							answer < 0.0 ifTrue: [answer := 0.0]]].
	^ answer! !

!Modal4 methodsFor: 'generation' stamp: 'len 8/27/2000 03:46'!
damp: amp
	| freq |
	1 to: 4 do: [ :i |
		(ratios at: i) < 0.0
			ifTrue: [freq := (ratios at: i) negated]
			ifFalse: [freq := (ratios at: i) * frequency].
		(filters at: i) frequency: freq resonance: (resonances at: i) * amp]! !

!ADSR methodsFor: 'accessing' stamp: 'len 5/29/2000 05:19'!
decayRate: aNumber
	decayRate := aNumber abs! !

!ADSR methodsFor: 'private' stamp: 'len 5/28/2000 06:06'!
decayState
	^ 1! !

!ADSR methodsFor: 'generation-private' stamp: 'len 6/3/2000 21:14'!
decayTick
	value := value - decayRate.
	value <= sustainLevel
		ifTrue: [value := sustainLevel.
				rate := 0.0.
				state := self sustainState].
	^ value! !

!ADSR methodsFor: 'accessing' stamp: 'len 5/29/2000 02:32'!
decayTime: aNumber
	self decayRate: 1.0 / self samplingRate / aNumber! !

!DLineA methodsFor: 'accessing' stamp: 'len 6/4/2000 01:31'!
delay: lag
	| outPointer |
	inPoint := inPoint - 1. outPoint := outPoint - 1.
	lag > (length - 1)
		ifTrue: [outPointer := inPoint + 1.0]
		ifFalse: [lag < 0.1
					ifTrue: [outPointer := inPoint + 0.8999999999]
					ifFalse: [outPointer := inPoint - lag + 1.0]].

	outPointer < 0 ifTrue: [outPointer := outPointer + length].

	outPoint := outPointer truncated. "Integer part of delay."
	alpha := 1.0 + outPoint - outPointer. "Fractional part of delay."

	alpha = 0.0 "exact integer delay"
		ifTrue: [outPoint := outPoint - 1.
				outPoint < 0 ifTrue: [outPoint := outPoint + length]].

	alpha < 0.1 "Hack to avoid pole/zero cancellation. Keeps allpass delay in range of .1 to 1.1"
		ifTrue: [outPoint := outPoint + 1.
				outPoint >= length ifTrue: [outPoint := outPoint - length].
				alpha := alpha + 1.0].

	coefficient := 1.0 - alpha / (1.0 + alpha). "coefficient for all pass"

	inPoint := inPoint + 1. outPoint := outPoint + 1! !

!DLineL methodsFor: 'accessing' stamp: 'len 6/3/2000 20:06'!
delay: lag
	| outPointer |
	lag > (length - 1)
		ifTrue: [outPointer := inPoint + 1]
		ifFalse: [outPointer := inPoint - lag].
	[outPointer < 1] whileTrue: [outPointer := outPointer + length].
	outPoint := outPointer truncated.
	alpha := outPointer - outPoint! !

!DLineN methodsFor: 'accessing' stamp: 'len 5/29/2000 05:02'!
delay: lag
	outPoint := inPoint - lag.
	[outPoint <= 0] whileTrue: [outPoint := outPoint + length] "modulo maximum length"! !

!PluckedString methodsFor: 'accessing' stamp: 'len 6/3/2000 23:42'!
detune: aNumber
	self frequency: lastFrequency detune: aNumber! !

!Modal4 methodsFor: 'accessing' stamp: 'len 5/28/2000 23:25'!
directGain: aNumber
	directGain := aNumber! !

!Instrument methodsFor: 'examples-scores' stamp: 'len 9/3/2000 03:59'!
duelingbScore
	"
	Mandolin new duelingbScore play
	Sitar new duelingbScore play
	"
	^ self soundForScore: (self scoreFrom:
'NoteOn          0.000000 1 57 50.800001
NoteOn          0.100000 1 57 50.800001
NoteOn          0.100000 1 57 127.000000
NoteOn          0.200000 1 59 63.500000
NoteOff         0.100000 1 59 63.500000
NoteOn          0.100000 1 61 127.000000
NoteOff         0.100000 1 61 63.500000
NoteOn          0.100000 1 62 127.000000
NoteOff         0.100000 1 62 63.500000
NoteOn          0.100000 1 64 114.299997
NoteOn          0.200000 1 62 63.500000
NoteOff         0.100000 1 62 63.500000
NoteOn          0.100000 1 61 127.000000
NoteOn          0.400000 1 69 127.000000
NoteOn          0.200000 1 69 12.700000
NoteOff         0.049977 1 69 63.500000
NoteOn          0.049977 1 73 63.500000
NoteOff         0.049977 1 73 63.500000
NoteOn          0.049977 1 71 63.500000
NoteOff         0.100000 1 71 63.500000
NoteOn          0.100000 1 85 127.000000
NoteOn          0.200000 1 45 50.800001
NoteOff         0.400000 1 45 63.500000
')! !

!Flute methodsFor: 'accessing' stamp: 'len 5/29/2000 19:51'!
endReflection: aNumber
	endReflection := aNumber! !

!Instrument methodsFor: 'error handling' stamp: 'len 9/2/2000 17:01'!
errorUndefinedControl: anObject
	Transcript cr; show: 'error undefined control ', anObject asString! !

!Instrument methodsFor: 'examples-scores' stamp: 'len 9/2/2000 20:20'!
flutebachScore
	"
	Flute new flutebachScore play
	"
	^ self soundForScore: (self scoreFrom:
'NoiseLevel	0.000 1 30.0
NoteOn          0.000 1 79 80.000000
NoteOff         0.100 1 79 63.500000
NoteOn          0.100 1 84 90.000000
NoteOff         0.100 1 84 63.500000
NoteOn          0.100 1 79 70.000000
NoteOff         0.100 1 79 63.500000

NoteOn          0.100 1 76 120.000000
NoteOn          0.100 1 77 110.000000
NoteOn          0.100 1 79 70.000000
NoteOff         0.100 1 79 70.0
NoteOn          0.100 1 79 90.000000
NoteOff         0.150 1 79 63.500000

NoteOn          0.050 1 79 80.000000
NoteOff         0.100 1 79 63.500000
NoteOn          0.100 1 84 90.000000
NoteOff         0.100 1 84 63.500000
NoteOn          0.100 1 79 70.000000
NoteOff         0.100 1 79 63.500000

NoteOn          0.100 1 76 70.000000
NoteOn          0.100 1 77 70.000000
NoteOn          0.100 1 79 80.000000
NoteOff         0.100 1 79 70.0
NoteOn          0.100 1 79 90.000000
NoteOff         0.150 1 79 63.500000

NoteOn          0.050 1 81 120.000000
NoteOn          0.100 1 79 110.000000
NoteOn          0.100 1 77 70.000000
NoteOn          0.100 1 76 120.000000
NoteOn          0.100 1 74 110.000000
NoteOn          0.100 1 72 70.000000

NoteOn          0.100 1 81 120.000000
NoteOn          0.200 1 82 60.000000
NoteOff		0.100 1 82 64.000000
NoteOn          0.100 1 81 110.000000
NoteOn          0.200 1 79 60.000000
NoteOff		0.100 1 79 64.000000
NoteOn          0.100 1 77 110.000000
NoteOn          0.200 1 76 60.000000
NoteOff		0.100 1 76 64.000000

NoteOn          0.100 1 77 120.000000
NoteOn          0.100 1 76 110.000000
NoteOn          0.100 1 74 70.000000
NoteOn          0.100 1 76 120.000000
NoteOn          0.100 1 77 110.000000
NoteOff		0.100 1 77 64.000000

NoteOn          0.100 1 79 120.000000
NoteOn          0.100 1 81 110.000000
NoteOn          0.100 1 79 70.000000
NoteOn          0.100 1 77 120.000000
NoteOn          0.100 1 76 110.000000
NoteOn          0.100 1 74 110.000000

NoteOn          0.100 1 79 120.000000
NoteOn          0.200 1 81 110.000000
NoteOn          0.200 1 79 70.000000
NoteOn          0.200 1 77 120.000000
NoteOn          0.200 1 76 110.000000
NoteOn          0.200 1 74 110.000000
NoteOff          0.100 1 74 110.000000

NoteOn          0.100 1 76 120.000000
NoteOn          0.100 1 74 110.000000
NoteOn          0.100 1 72 70.000000
NoteOn          0.100 1 74 120.000000
NoteOff         0.070 1 74 120.000000

NoteOn          0.030 1 76 100.000000
NoteOff         0.070 1 76 120.000000
NoteOn          0.030 1 77 100.000000
NoteOff         0.070 1 77 120.000000
NoteOn          0.030 1 79 100.000000
NoteOff         0.070 1 79 120.000000
NoteOn          0.030 1 81 100.000000
NoteOff         0.070 1 81 120.000000
NoteOn          0.030 1 82 100.000000
NoteOff         0.070 1 82 120.000000
NoteOn          0.030 1 81 100.000000
NoteOff         0.070 1 81 120.000000
NoteOn          0.030 1 82 100.000000
NoteOff         0.070 1 82 120.000000
NoteOn          0.030 1 79 100.000000
NoteOff         0.070 1 79 120.000000

NoiseLevel	0.000 1 40.0
ModWheel	0.000 1 25.0
NoteOn          0.030 1 77 120.000000
NoteOn          1.000 1 89 100.000000
NoteOff         0.200 1 77 120.000000')! !

!WvIn methodsFor: 'accessing' stamp: 'len 6/3/2000 18:15'!
frequency
	^ self rate * self samplingRate / length! !

!BowedString methodsFor: 'accessing' stamp: 'len 5/29/2000 05:06'!
frequency: freq
	baseDelay := self samplingRate / freq - 4.0. "delay - approx. filter delay"
	bridgeDelay delay: betaRatio * baseDelay. "bow to bridge length"
	neckDelay delay: 1.0 - betaRatio * baseDelay "bow to nut (finger) length"! !

!Clarinet methodsFor: 'accessing' stamp: 'len 5/29/2000 18:57'!
frequency: freq
	delayLine delay: self samplingRate / freq / 2.0 - 1.5 "length - approx. filter delay"! !

!Drone methodsFor: 'accessing' stamp: 'len 9/3/2000 03:13'!
frequency: freq
	delayLine delay: self samplingRate / freq - 0.5.
	loopGain := freq * 0.000002 + 0.997 min: 0.99999! !

!FM4Op methodsFor: 'accessing' stamp: 'len 8/26/2000 22:23'!
frequency: freq
	frequency := freq.
	waves with: ratios do: [ :wave :ratio | wave frequency: freq * ratio]! !

!Flute methodsFor: 'accessing' stamp: 'len 5/29/2000 19:53'!
frequency: freq
	| length |
	lastFrequency := freq * 0.66666. "We're overblowing here."
	length := self samplingRate / lastFrequency - 2.0. "Length - approx. filter delay."
	boreDelay delay: length. "Length of bore tube."
	jetDelay delay: length * jetRatio "Jet delay shorter"! !

!Instrument methodsFor: 'accessing' stamp: 'len 5/28/2000 16:10'!
frequency: aNumber
	^ self! !

!Modal4 methodsFor: 'accessing' stamp: 'len 8/27/2000 03:47'!
frequency: freq
	frequency := freq.
	1 to: 4 do: [ :i | self setFilterIndex: i ratio: (ratios at: i) resonance: (resonances at: i)]! !

!PluckedString methodsFor: 'accessing' stamp: 'len 6/3/2000 23:42'!
frequency: aNumber
	self frequency: aNumber detune: detuning! !

!Rhodey methodsFor: 'accessing' stamp: 'len 8/26/2000 23:57'!
frequency: freq
	super frequency: freq * 2.0! !

!Sitar methodsFor: 'accessing' stamp: 'len 9/3/2000 03:14'!
frequency: freq
	delayTarget := self samplingRate / freq.
	delay := noise tick * 0.05 + 1.0 * delayTarget.
	delayLine delay: delay.
	loopGain := freq * 0.000001 + 0.995 min: 0.9995! !

!Wurley methodsFor: 'accessing' stamp: 'len 8/27/2000 02:48'!
frequency: freq
	frequency := freq.
	(waves at: 1) frequency: freq * (ratios at: 1).
	(waves at: 2) frequency: freq * (ratios at: 2).
	(waves at: 3) frequency: (ratios at: 3).
	(waves at: 4) frequency: (ratios at: 4)! !

!WvIn methodsFor: 'accessing' stamp: 'len 5/28/2000 20:48'!
frequency: aNumber
	self rate: length * aNumber / self samplingRate! !

!PluckedString methodsFor: 'accessing' stamp: 'len 6/3/2000 23:42'!
frequency: aNumber detune: anotherNumber
	lastFrequency := aNumber.
	detuning := anotherNumber.
	lastLength := self samplingRate / lastFrequency.
	loopGain := aNumber * 0.000005 + baseLoopGain.
	loopGain > 1.0 ifTrue: [loopGain := 0.99999].

	delayLine delay: lastLength / detuning - 0.5.
	delayLine2 delay: lastLength * detuning - 0.5! !

!TwoPole methodsFor: 'accessing' stamp: 'len 5/28/2000 05:13'!
frequency: freq resonance: reson
	p1 := reson squared negated.
	p0 := 2.0 * reson * (Float pi * 2.0 * freq / self samplingRate)! !

!MonoWvIn class methodsFor: 'instance creation' stamp: 'len 5/30/2000 07:47'!
fromFileNamed: fileName looping: aBoolean
	| answer file |
	answer := self fromStream: (file := FileStream readOnlyFileNamed: fileName) binary looping: aBoolean.
	file close.
	^ answer! !

!MonoWvIn class methodsFor: 'instance creation' stamp: 'len 5/30/2000 07:43'!
fromStream: aStream looping: aBoolean
	^ self new fromStream: aStream looping: aBoolean! !

!WvIn class methodsFor: 'examples' stamp: 'spfa 11/18/2009 18:17'!
fwavblnk
	"
	(WvIn fwavblnk asSampledSoundCount: 10000) play
	"
	^ MonoWvIn loopFromFileNamed: 'rawwaves', FileDirectory slash,'fwavblnk.raw'! !

!Amp methodsFor: 'as yet unclassified' stamp: 'spfa 1/18/2022 15:08'!
gain

	^ gain! !

!Amp methodsFor: 'as yet unclassified' stamp: 'spfa 1/18/2022 15:08'!
gain: aNumber
	gain := aNumber! !

!BiQuad methodsFor: 'accessing' stamp: 'len 5/28/2000 03:30'!
gain: aNumber
	gain := aNumber! !

!OnePole methodsFor: 'accessing' stamp: 'len 5/28/2000 04:33'!
gain: aNumber
	gain := aNumber.
	self normalizeGain! !

!OneZero methodsFor: 'accessing' stamp: 'len 5/28/2000 04:41'!
gain: aNumber
	gain := aNumber.
	self normalizeGain! !

!TwoPole methodsFor: 'accessing' stamp: 'len 5/28/2000 05:14'!
gain: aNumber
	gain := aNumber! !

!TwoZero methodsFor: 'accessing' stamp: 'len 5/28/2000 05:19'!
gain: aNumber
	gain := aNumber! !

!FM4Op methodsFor: 'accessing' stamp: 'len 8/26/2000 23:49'!
gains: aCollection
	aCollection withIndexDo: [ :each :index | self set: index gain: each]! !

!Instrument methodsFor: 'examples-scales' stamp: 'len 8/26/2000 17:58'!
hiMajorScale
	"
	Flute new hiMajorScale play
	"
	^ AbstractSound hiMajorScaleOn: self! !

!SubNoise methodsFor: 'accessing' stamp: 'len 5/28/2000 04:21'!
howOften: n
	howOften := n! !

!Envelope2 methodsFor: 'generation' stamp: 'len 5/28/2000 05:48'!
informTick
	self tick.
	^ state! !

!MonoWvIn methodsFor: 'generation' stamp: 'len 8/27/2000 02:14'!
informTick
	| currentTime intTime fracTime |
	finished ifTrue: [^ finished].
	currentTime := self currentTime.
	intTime := currentTime truncated. "Integer part of time address."
	interpolate
		ifTrue: [fracTime := currentTime - intTime. "Fractional part of time address."
				"Do linear interpolation."
				lastOutput := data at: intTime + 1.
				lastOutput := (data at: intTime + 2) - lastOutput * fracTime + lastOutput]
		ifFalse: [lastOutput := data at: intTime + 1].
	self updateTime.
	^ finished! !

!WvIn methodsFor: 'generation' stamp: 'len 6/3/2000 18:31'!
informTick
	| tempTime intTime fracTime |
	finished ifTrue: [^ finished].

	tempTime := time.

	phaseOffset ~= 0.0
		ifTrue: [tempTime := tempTime + phaseOffset. "Add phase offset."
				looping
					ifTrue: [[tempTime >= length] whileTrue: [tempTime := tempTime - length].
							[tempTime < 0.0] whileTrue: [tempTime := tempTime + length]]
					ifFalse: [tempTime >= length ifTrue: [tempTime := length - 1.0].
							tempTime < 0.0 ifTrue: [tempTime := 0.0]]].

	intTime := tempTime truncated. "Integer part of time address."

	interpolate
		ifTrue: [fracTime := tempTime - intTime. "Fractional part of time address."
				"Do linear interpolation."
				1 to: channels do: [ :i |
					lastOutput at: i put: (self at: intTime + 1 channel: i).
					lastOutput at: i put: (self at: intTime + 2 channel: i) - (lastOutput at: i) * fracTime + (lastOutput at: i)]]
		ifFalse: [1 to: channels do: [ :i | lastOutput at: i put: (self at: intTime + 1 channel: i)]].

	time := time + rate. "Update current time."
	looping
		ifTrue: [[time >= length] whileTrue: [time := time - length].
				[time < 0.0] whileTrue: [time := time + length]]
		ifFalse: [time >= length ifTrue: [time := length - 1.0. finished := true].
				time < 0.0 ifTrue: [time := 0.0]].

	^ finished! !

!ADSR methodsFor: 'initialization' stamp: 'len 5/28/2000 05:53'!
initialize
	super initialize.
	attackRate := decayRate := 0.001.
	sustainLevel := 0.5.
	releaseRate := 0.01! !

!AgogoBell methodsFor: 'initialization' stamp: 'len 8/28/2000 20:42'!
initialize
	super initialize.
	wave := WvIn britestk normalize; rate: 7.0.
	self setFilterIndex: 1 ratio: 1.0 resonance: 0.999 gain: 0.06.
	self setFilterIndex: 1 ratio: 4.08 resonance: 0.999 gain: 0.05.
	self setFilterIndex: 1 ratio: 6.669 resonance: 0.999 gain: 0.03.
	self setFilterIndex: 1 ratio: -3725.0 resonance: 0.999 gain: 0.02.
	directGain := 0.25! !

!Amp methodsFor: 'as yet unclassified' stamp: 'spfa 1/18/2022 15:32'!
initialize
	super initialize.
	gain := 1.0.
	self clear! !

!BeeThree methodsFor: 'initialization' stamp: 'len 9/2/2000 21:49'!
initialize
	super initialize.
	waves := #(sinewave sinewave sinewave fwavblnk) collect: [ :each | (WvIn perform: each) normalize].
	self ratios: #(0.999 1.997 3.006 6.009).
	self gains: (#(96 96 100 96) collect: [ :each | Gains at: each]).
	twozero gain: 0.1.
	adsr first attackTime: 0.005; decayTime: 0.003; sustainLevel: 1.0; releaseTime: 0.01.
	adsr second attackTime: 0.005; decayTime: 0.003; sustainLevel: 1.0; releaseTime: 0.01.
	adsr third attackTime: 0.005; decayTime: 0.003; sustainLevel: 1.0; releaseTime: 0.01.
	adsr fourth attackTime: 0.005; decayTime: 0.001; sustainLevel: 0.4; releaseTime: 0.03! !

!BowTable methodsFor: 'initialization' stamp: 'len 5/28/2000 20:31'!
initialize
	offset := 0.0. "offset is a bias, really not needed unless friction is different in each direction."
	slope := 0.1 "controls width of friction pulse, related to bowForce."! !

!DCBlock methodsFor: 'initialization' stamp: 'len 5/28/2000 15:30'!
initialize
	super initialize.
	self clear! !

!Envelope2 methodsFor: 'initialization' stamp: 'len 6/3/2000 20:37'!
initialize
	target := value := 0.0.
	rate := 0.001.
	state := 0! !

!FM4Op class methodsFor: 'class initialization' stamp: 'len 8/27/2000 00:30'!
initialize
	"
	FM4Op initialize
	"
	Gains := ((99 to: 0 by: -1) collect: [ :each | 0.933033 raisedTo: each]) asFloatArray.
	SustainLevels := ((15 to: 0 by: -1) collect: [ :each | 0.707101 raisedTo: each]) asFloatArray.
	SustainLevels := ((0 to: 32) collect: [ :each | 8.498186 * (0.707101 raisedTo: each)]) asFloatArray! !

!Filter methodsFor: 'initialization' stamp: 'len 5/28/2000 03:24'!
initialize
	^ self! !

!JetTable methodsFor: 'initialization' stamp: 'len 5/28/2000 16:03'!
initialize
	lastOutput := 0.0! !

!LipFilter methodsFor: 'initialization' stamp: 'len 5/28/2000 05:28'!
initialize
	filter := BiQuad new zeroCoeffs: {0. 0}.
	self clear! !

!Marimba methodsFor: 'initialization' stamp: 'len 5/30/2000 07:51'!
initialize
	super initialize.
	wave := WvIn marimbaStick.
	wave normalize; rate: 0.5. "normal stick"

	self setFilterIndex: 1 ratio: 1.0 resonance: 0.9996 gain: 0.04.
	self setFilterIndex: 2 ratio: 3.99 resonance: 0.9994 gain: 0.01.
	self setFilterIndex: 3 ratio: 10.65 resonance: 0.9994 gain: 0.01.
	self setFilterIndex: 4 ratio: -2443.0 resonance: 0.999 gain: 0.008.

	directGain := 0.1.
	multiStrike := 0! !

!Noise methodsFor: 'initialization' stamp: 'len 8/28/2000 20:49'!
initialize
	seed := 17! !

!OnePole methodsFor: 'initialization' stamp: 'len 6/3/2000 20:27'!
initialize
	super initialize.
	coefficient := 0.9.
	gain := 1.0.
	sgain := 0.1.
	self clear! !

!OneZero methodsFor: 'initialization' stamp: 'len 6/3/2000 20:21'!
initialize
	super initialize.
	coefficient := 1.0.
	gain := 1.0.
	sgain := 0.5.
	self clear! !

!ReedTable methodsFor: 'initialization' stamp: 'len 5/28/2000 20:22'!
initialize
	offset := 0.6. "offset is a bias, related to reed rest position."
	slope := -0.8 "slope corresponds loosely to reed stiffness."! !

!Rhodey methodsFor: 'initialization' stamp: 'len 8/27/2000 01:11'!
initialize
	super initialize.
	waves := #(sinewave sinewave sinewave fwavblnk) collect: [ :each | (WvIn perform: each) normalize].
	self ratios: #(1.0 0.5 1.0 15.0).
	self gains: (#(100 91 100 68) collect: [ :each | Gains at: each]).
	twozero gain: 1.0.
	adsr first attackTime: 0.001; decayTime: 1.5; sustainLevel: 0.0; releaseTime: 0.04.
	adsr second attackTime: 0.001; decayTime: 1.5; sustainLevel: 0.0; releaseTime: 0.04.
	adsr third attackTime: 0.001; decayTime: 1.0; sustainLevel: 0.0; releaseTime: 0.04.
	adsr fourth attackTime: 0.001; decayTime: 0.25; sustainLevel: 0.0; releaseTime: 0.04! !

!TubularBell methodsFor: 'initialization' stamp: 'len 8/27/2000 03:05'!
initialize
	super initialize.
	waves := #(sinewave sinewave sinewave fwavblnk) collect: [ :each | (WvIn perform: each) normalize].
	self ratios: {1.0*0.995. 1.414*0.995. 1.0*1.005. 1.414}.
	self gains: (#(95 77 100 72) collect: [ :each | Gains at: each]).
	twozero gain: 0.5.
	vibWave frequency: 2.0.
	adsr first attackTime: 0.005; decayTime: 4.0; sustainLevel: 0.0; releaseTime: 0.04.
	adsr second attackTime: 0.005; decayTime: 4.0; sustainLevel: 0.0; releaseTime: 0.04.
	adsr third attackTime: 0.001; decayTime: 4.0; sustainLevel: 0.0; releaseTime: 0.04.
	adsr fourth attackTime: 0.004; decayTime: 4.0; sustainLevel: 0.0; releaseTime: 0.04! !

!Vibraphone methodsFor: 'initialization' stamp: 'len 5/30/2000 07:58'!
initialize
	super initialize.
	wave := WvIn marimbaStick.
	wave normalize; rate: 13.33.
	vibr frequency: 4.0.
	onepole coefficient: 0.2.
	self setFilterIndex: 1 ratio: 1.0 resonance: 0.99995 gain: 0.025.
	self setFilterIndex: 2 ratio: 2.01 resonance: 0.99991 gain: 0.015.
	self setFilterIndex: 3 ratio: 3.9 resonance: 0.99992 gain: 0.015.
	self setFilterIndex: 4 ratio: 14.37 resonance: 0.99990 gain: 0.015.
	masterGain := 1.0.
	directGain := 0.0.
	vibrGain := 0.2! !

!Wurley methodsFor: 'initialization' stamp: 'len 8/27/2000 03:05'!
initialize
	super initialize.
	waves := #(sinewave sinewave sinewave fwavblnk) collect: [ :each | (WvIn perform: each) normalize].
	self ratios: #(1.0 4.0 -510.0 -510.0).
	self gains: (#(100 83 93 69) collect: [ :each | Gains at: each]).
	twozero gain: 2.0.
	vibWave frequency: 8.0.
	adsr first attackTime: 0.001; decayTime: 1.5; sustainLevel: 0.0; releaseTime: 0.04.
	adsr second attackTime: 0.001; decayTime: 1.5; sustainLevel: 0.0; releaseTime: 0.04.
	adsr third attackTime: 0.001; decayTime: 0.25; sustainLevel: 0.0; releaseTime: 0.04.
	adsr fourth attackTime: 0.001; decayTime: 0.15; sustainLevel: 0.0; releaseTime: 0.04! !

!WvIn methodsFor: 'initialization' stamp: 'len 5/28/2000 22:25'!
initialize
	time := 0.0.
	phaseOffset := 0.0.
	rate := 1.0.
	interpolate := false.
	looping := false.
	finished := false! !

!Filter methodsFor: 'initialization' stamp: 'len 5/28/2000 05:07'!
initialize: anInteger
	self initialize! !

!BowedString methodsFor: 'initialization' stamp: 'len 5/30/2000 07:31'!
initializeForLowestFrequency: lowestFreq
	| length |
	length := (self samplingRate / lowestFreq + 1) truncated.
	neckDelay := DLineL new: length.
	length := length // 2.
	bridgeDelay := DLineL new: length.
	bowTable := BowTable new.
	reflFilt := OnePole new.
	bodyFilt := BiQuad new.

	vibr := WvIn sinewave.

	adsr := ADSR new.
	vibrGain := 0.0.

	neckDelay delay: 100.0.
	bridgeDelay delay: 29.0.

	bowTable slope: 3.0.

	reflFilt coefficient: 0.6 - (0.1 * 22050.0 / self samplingRate); gain: 0.95.

	bodyFilt frequency: 500.0 resonance: 0.85; setEqualGainZeros; gain: 0.2.

	vibr normalize; frequency: 6.12723.

	adsr attackTime: 0.02; decayTime: 0.005; sustainLevel: 0.9; releaseTime: 0.01.

	betaRatio := 0.127236.

	maxVelocity := 0.0! !

!Clarinet methodsFor: 'initialization' stamp: 'len 5/30/2000 07:32'!
initializeForLowestFrequency: lowestFreq
	| length |
	length := (self samplingRate / lowestFreq + 1) truncated.
	delayLine := DLineL new: length.
	reedTable := ReedTable new offset: 0.7; slope: -0.3.
	filter := OneZero new.
	envelope := Envelope2 new.
	noise := Noise new.

	vibr := WvIn sinewave.
	vibr normalize; frequency: 5.735.

	outputGain := 1.0.
	noiseGain := 0.2.
	vibrGain := 0.1.

	self clear.

	self frequency: 440.0! !

!Drone methodsFor: 'initialization' stamp: 'len 9/3/2000 03:09'!
initializeForLowestFrequency: lowestFreq
	| length |
	length := self samplingRate // lowestFreq + 1.
	loopGain := 0.999.
	loopFilter := OneZero new.
	delayLine := DLineA new: length.
	envelope := ADSR new attackTime: 2.0; decayTime: 0.5; sustainLevel: 0.0; releaseTime: 0.5.
	noise := Noise new.
	self clear! !

!Flute methodsFor: 'initialization' stamp: 'len 9/2/2000 16:12'!
initializeForLowestFrequency: lowestFreq
	| length |
	length := (self samplingRate / lowestFreq + 1) truncated.
	boreDelay := DLineL new: length.
	length := length // 2.
	jetDelay := DLineL new: length.
	jetTable := JetTable new.
	filter := OnePole new.
	dcBlock := DCBlock new.
	noise := Noise new.
	adsr := ADSR new.

	vibr := WvIn sinewave.
	vibr normalize; frequency: 5.925.

	self clear.

	boreDelay delay: 100.0.
	jetDelay delay: 49.0.

	filter coefficient: -0.1 * 22050 / self samplingRate + 0.7; gain: -1.0.

	adsr attackTime: 0.005; decayTime: 0.01; sustainLevel: 0.8; releaseTime: 0.010.

	endReflection := 0.5.
	jetReflection := 0.5.
	noiseGain := 0.09. "Breath pressure random component." self flag: #hack.
	vibrGain := 0.05. "Breath periodic vibrato component."

	jetRatio := 0.32.
	maxPressure := 0.0.

	outputGain := 0.0! !

!Mandolin methodsFor: 'initialization' stamp: 'spfa 11/18/2009 18:13'!
initializeForLowestFrequency: lowestFreq
	super initializeForLowestFrequency: lowestFreq.
	waves := (1 to: 12) collect: [ :i | MonoWvIn oneshotFromFileNamed: 'rawwaves', FileDirectory slash, 'mand', i printString, '.raw'].
	mic := 1.
	dampTime := 0.
	waveDone := true! !

!PluckedString methodsFor: 'initialization' stamp: 'len 6/4/2000 01:34'!
initializeForLowestFrequency: lowestFreq
	length := (self samplingRate / lowestFreq + 1) truncated.
	baseLoopGain := 0.995.
	loopGain := 0.999.
	delayLine := DLineA new: length.
	delayLine2 := DLineA new: length.
	combDelay := DLineL new: length.
	filter := OneZero new.
	filter2 := OneZero new.
	pluckAmplitude := 0.3.
	pluckPosition := 0.4.
	detuning := 0.995.
	lastFrequency := lowestFreq * 2.0.
	lastLength := length * 0.5! !

!Sitar methodsFor: 'initialization' stamp: 'len 9/3/2000 03:04'!
initializeForLowestFrequency: lowestFreq
	| length |
	length := self samplingRate // lowestFreq + 1.
	loopGain := 0.999.
	loopFilter := OneZero new coefficient: 0.01.
	delayLine := DLineA new: length.
	delay := length // 2.
	delayTarget := delay.
	envelope := ADSR new attackTime: 0.001; decayTime: 0.04; sustainLevel: 0.0; releaseTime: 0.5.
	noise := Noise new.
	self clear! !

!ADSR methodsFor: 'testing' stamp: 'len 9/2/2000 22:46'!
isAttacking
	^ state == self attackState! !

!ADSR methodsFor: 'testing' stamp: 'len 9/2/2000 22:46'!
isDecaying
	^ state == self decayState! !

!WvIn methodsFor: 'testing' stamp: 'len 5/29/2000 02:53'!
isFinished
	^ finished! !

!ADSR methodsFor: 'testing' stamp: 'len 9/2/2000 22:47'!
isReleasing
	^ state == self releaseState! !

!ADSR methodsFor: 'testing' stamp: 'len 9/2/2000 22:47'!
isSustaining
	^ state == self sustainState! !

!Flute methodsFor: 'accessing' stamp: 'len 5/29/2000 19:53'!
jetDelay: ratio
	| length |
	length := self samplingRate / lastFrequency - 2.0. "Length - approx. filter delay."
	jetRatio := ratio.
	jetDelay delay: length * ratio "Scaled by ratio."! !

!Flute methodsFor: 'accessing' stamp: 'len 5/29/2000 19:51'!
jetReflection: aNumber
	jetReflection := aNumber! !

!ADSR methodsFor: 'events' stamp: 'len 5/28/2000 05:53'!
keyOff
	target := 0.0.
	rate := releaseRate.
	state := 3! !

!Envelope2 methodsFor: 'events' stamp: 'len 5/28/2000 05:44'!
keyOff
	target := 0.0.
	value ~= target ifTrue: [state := 1]! !

!FM4Op methodsFor: 'events' stamp: 'len 8/26/2000 22:21'!
keyOff
	adsr do: [ :each | each keyOff]! !

!ADSR methodsFor: 'events' stamp: 'len 5/28/2000 05:54'!
keyOn
	target := 1.0.
	rate := attackRate.
	state := 0! !

!Envelope2 methodsFor: 'events' stamp: 'len 5/28/2000 05:44'!
keyOn
	target := 1.0.
	value ~= target ifTrue: [state := 1]! !

!FM4Op methodsFor: 'events' stamp: 'len 8/26/2000 22:20'!
keyOn
	adsr do: [ :each | each keyOn]! !

!BowTable methodsFor: 'accessing' stamp: 'len 5/28/2000 20:32'!
lastOut
	^ lastOutput! !

!Envelope2 methodsFor: 'generation' stamp: 'len 5/28/2000 05:48'!
lastOut
	^ value! !

!Filter methodsFor: 'accessing' stamp: 'len 5/28/2000 03:20'!
lastOut
	^ lastOutput! !

!Instrument methodsFor: 'accessing' stamp: 'len 5/28/2000 16:09'!
lastOut
	^ lastOutput! !

!JetTable methodsFor: 'accessing' stamp: 'len 5/28/2000 16:04'!
lastOut
	^ lastOutput! !

!LipFilter methodsFor: 'accessing' stamp: 'len 5/28/2000 05:36'!
lastOut
	^ lastOutput! !

!MonoWvIn methodsFor: 'accessing' stamp: 'len 8/27/2000 01:37'!
lastOut
	^ lastOutput! !

!Noise methodsFor: 'accessing' stamp: 'len 8/28/2000 20:50'!
lastOut
	^ lastOutput! !

!ReedTable methodsFor: 'accessing' stamp: 'len 5/28/2000 20:24'!
lastOut
	^ lastOutput! !

!WvIn methodsFor: 'accessing' stamp: 'len 8/27/2000 01:23'!
lastOut
	^ lastOutput size = 1 ifTrue: [lastOutput at: 1] ifFalse: [lastOutput average]! !

!Brass methodsFor: 'accessing' stamp: 'len 5/29/2000 20:45'!
lipTension: aNumber
	lipFilter frequency: lipTarget * (4.0 raisedTo: 2.0 * aNumber - 1.0)! !

!BowTable methodsFor: 'accessing' stamp: 'len 5/28/2000 20:32'!
lookup: sample
	^ self tick: sample! !

!JetTable methodsFor: 'accessing' stamp: 'len 6/3/2000 21:01'!
lookup: sample
	lastOutput := sample * sample * sample - sample. "(x^3 - x) approximated sigmoid of jet."
	lastOutput > 1.0 ifTrue: [lastOutput := 1.0]. "Saturation at +/- 1.0."
	lastOutput < -1.0 ifTrue: [lastOutput := -1.0].
	^ lastOutput! !

!ReedTable methodsFor: 'accessing' stamp: 'len 5/28/2000 20:24'!
lookup: deltaP
	^ self tick: deltaP! !

!MonoWvIn class methodsFor: 'instance creation' stamp: 'len 5/28/2000 22:24'!
loopFromFileNamed: fileName
	^ self fromFileNamed: fileName looping: true! !

!Instrument methodsFor: 'examples-scales' stamp: 'len 8/26/2000 17:58'!
lowMajorScale
	"
	BowedString new lowMajorScale play
	"
	^ AbstractSound lowMajorScaleOn: self! !

!BowedString class methodsFor: 'instance creation' stamp: 'len 5/29/2000 05:16'!
lowestFrequency: lowestFreq
	^ super new initializeForLowestFrequency: lowestFreq! !

!Brass class methodsFor: 'instance creation' stamp: 'len 5/29/2000 20:55'!
lowestFrequency: lowestFreq
	^ super new initializeForLowestFrequency: lowestFreq! !

!Clarinet class methodsFor: 'instance creation' stamp: 'len 5/29/2000 18:53'!
lowestFrequency: lowestFreq
	^ super new initializeForLowestFrequency: lowestFreq! !

!Drone class methodsFor: 'instance creation' stamp: 'len 9/3/2000 03:17'!
lowestFrequency: lowestFreq
	^ super new initializeForLowestFrequency: lowestFreq! !

!Flute class methodsFor: 'instance creation' stamp: 'len 5/29/2000 20:17'!
lowestFrequency: lowestFreq
	^ super new initializeForLowestFrequency: lowestFreq! !

!PluckedString class methodsFor: 'instance creation' stamp: 'len 6/3/2000 21:33'!
lowestFrequency: lowestFreq
	^ super new initializeForLowestFrequency: lowestFreq! !

!Sitar class methodsFor: 'instance creation' stamp: 'len 9/3/2000 02:46'!
lowestFrequency: lowestFreq
	^ super new initializeForLowestFrequency: lowestFreq! !

!Instrument methodsFor: 'examples-scales' stamp: 'len 8/27/2000 04:16'!
majorChord
	"
	Vibraphone new majorChord play
	Marimba new majorChord play
	Brass new majorChord play
	Rhodey new majorChord play
	Wurley new majorChord play
	TubularBell new majorChord play
	"
	^ AbstractSound majorChordOn: self from: #c4! !

!Instrument methodsFor: 'examples-scales' stamp: 'len 8/26/2000 17:58'!
majorScale
	"
	Clarinet new majorScale play
	Flute new majorScale play
	Mandolin new majorScale play
	"
	^ AbstractSound majorScaleOn: self! !

!WvIn class methodsFor: 'examples' stamp: 'len 8/27/2000 01:43'!
marimbaStick
	"
	WvIn marimbaStick asSampledSound play
	"
	^ MonoWvIn fromStream: (ReadStream on: #(0 20 255 143 2 11 251 45 8 13 21 150 227 8 253 105 2 48 4 50 3 156 247 150 13 28 238 172 244 175 17 84 4 189 3 220 252 255 249 124 15 111 227 103 30 28 218 26 49 59 209 115 26 100 9 216 222 104 39 62 211 81 45 250 216 252 20 19 2 228 247 219 2 59 3 35 253 235 248 203 11 248 242 18 27 149 210 148 40 146 234 235 3 169 12 42 234 203 28 1 225 101 23 104 252 163 253 224 250 154 10 79 240 53 9 41 253 65 255 238 10 67 231 228 29 137 233 242 4 69 14 62 239 173 15 47 238 141 8 208 5 94 239 219 17 43 252 209 243 224 17 131 237 248 15 221 245 182 251 176 21 115 231 11 19 99 250 147 252 86 3 243 245 209 9 27 3 116 246 80 14 24 246 53 250 113 8 20 243 67 17 160 244 247 6 9 2 225 244 26 9 13 251 82 255 94 6 142 250 141 5 100 252 226 250 227 10 146 243 232 5 13 4 190 248 41 10 89 247 5 4 194 1 32 246 0 12 10 249 205 1 60 2 153 251 218 2 204 253 70 251 192 13 21 244 132 6 196 255 206 246 253 14 3 242 170 14 228 246 125 255 111 7 218 244 99 7 67 254 9 254 170 2 132 0 8 253 200 8 96 240 169 13 128 249 109 252 225 11 1 243 59 15 158 243 88 4 224 4 101 246 220 5 15 253 202 255 200 4 6 252 115 1 176 1 186 245 69 13 66 248 29 3 116 4 170 245 237 11 111 244 108 4 119 2 127 247 6 13 32 246 236 5 20 2 159 245 239 8 82 250 35 3 142 1 141 253 152 2 0 254 158 250 129 7 244 251 206 0 158 3 154 247 86 9 255 247 238 5 6 1 148 249 78 9 134 247 218 4 102 1 194 250 87 5 110 249 245 2 141 2 161 250 231 6 60 252 180 253 211 4 236 248 212 7 225 254 42 253 11 6 163 247 15 5 157 253 223 0 76 4 82 250 234 2 182 254 171 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)) looping: false! !

!Modal4 methodsFor: 'accessing' stamp: 'len 5/28/2000 23:25'!
masterGain: aNumber
	masterGain := aNumber! !

!Instrument methodsFor: 'examples-scores' stamp: 'len 10/2/2000 09:21'!
misaCriollaScore
	"Ariel Ramirez's!!"
	"
	Clarinet new misaCriollaScore play
	Sitar new misaCriollaScore play
	"
	^ self soundForScore: (self scoreFrom:
'NoteOn          0.000000 1 67 127.000000
NoteOff         0.142494 1 67 63.500000
NoteOn          0.007528 1 67 127.000000
NoteOff         0.149977 1 67 63.500000
NoteOn          0.149977 1 67 127.000000
NoteOff         0.285034 1 67 63.500000
NoteOn          0.015011 1 69 127.000000
NoteOff         0.142494 1 69 63.500000
NoteOn          0.007528 1 67 127.000000
NoteOff         0.285034 1 67 63.500000
NoteOn          0.015011 1 64 127.000000
NoteOff         1.140000 1 64 63.500000
NoteOn          0.060000 1 64 127.000000
NoteOff         0.074966 1 64 63.500000
NoteOn          0.074966 1 64 127.000000
NoteOff         0.149977 1 64 63.500000
NoteOn          0.149977 1 64 127.000000
NoteOff         0.285034 1 64 63.500000
NoteOn          0.015011 1 62 127.000000
NoteOff         0.074966 1 62 63.500000
NoteOn          0.074966 1 60 127.000000
NoteOff         0.149977 1 60 63.500000
NoteOn          0.149977 1 57 127.000000
NoteOff         1.140000 1 57 63.500000
NoteOn          0.060000 1 79 127.000000
NoteOff         0.142494 1 79 63.500000
NoteOn          0.007528 1 79 127.000000
NoteOff         0.149977 1 79 63.500000
NoteOn          0.149977 1 79 127.000000
NoteOff         0.285034 1 79 63.500000
NoteOn          0.015011 1 81 127.000000
NoteOff         0.142494 1 81 63.500000
NoteOn          0.007528 1 79 127.000000
NoteOff         0.285034 1 79 63.500000
NoteOn          0.015011 1 76 127.000000
NoteOff         1.140000 1 76 63.500000
NoteOn          0.060000 1 76 127.000000
NoteOff         0.074966 1 76 63.500000
NoteOn          0.074966 1 76 127.000000
NoteOff         0.149977 1 76 63.500000
NoteOn          0.149977 1 76 127.000000
NoteOff         0.285034 1 76 63.500000
NoteOn          0.015011 1 74 127.000000
NoteOff         0.074966 1 74 63.500000
NoteOn          0.074966 1 72 127.000000
NoteOff         0.149977 1 72 63.500000
NoteOn          0.149977 1 69 127.000000
NoteOff         0.449977 1 69 63.500000
NoteOn          0.449977 1 79 127.000000
NoteOff         0.149977 1 79 63.500000
NoteOn          0.149977 1 81 127.000000
NoteOff         0.855011 1 81 63.500000
NoteOn          0.045034 1 91 127.000000
NoteOff         0.149977 1 91 63.500000
NoteOn          0.149977 1 93 127.000000
NoteOff         0.950023 1 93 63.500000
NoteOff         0.050023 1 93 63.500000')! !

!MonoWvIn methodsFor: 'accessing' stamp: 'len 8/27/2000 01:37'!
mlastOut
	^ Array with: lastOutput! !

!WvIn methodsFor: 'accessing' stamp: 'len 5/28/2000 21:00'!
mlastOut
	^ lastOutput! !

!FM4Op methodsFor: 'accessing' stamp: 'len 8/26/2000 22:24'!
modulationDepth: aNumber
	modulationDepth := aNumber! !

!Marimba methodsFor: 'accessing' stamp: 'len 5/29/2000 02:51'!
modulationDepth: mDepth
	^ self! !

!FM4Op methodsFor: 'accessing' stamp: 'len 8/26/2000 22:22'!
modulationSpeed: aNumber
	vibWave frequency: aNumber! !

!Marimba methodsFor: 'accessing' stamp: 'len 5/29/2000 02:51'!
modulationSpeed: mSpeed
	"don't bother here, marimba decay so fast mod doesn't make sense."
	^ self! !

!WvIn methodsFor: 'generation' stamp: 'len 5/28/2000 22:14'!
mtick
	self informTick.
	^ self mlastOut! !

!BowTable class methodsFor: 'instance creation' stamp: 'len 5/28/2000 20:35'!
new
	^ super new initialize! !

!BowedString class methodsFor: 'instance creation' stamp: 'len 5/29/2000 05:17'!
new
	^ self lowestFrequency: 50! !

!Brass class methodsFor: 'instance creation' stamp: 'spfa 11/13/2017 13:41'!
new
	^ self lowestFrequency: 50! !

!Clarinet class methodsFor: 'instance creation' stamp: 'len 5/29/2000 19:21'!
new
	^ self lowestFrequency: 50.0! !

!Drone class methodsFor: 'instance creation' stamp: 'len 9/3/2000 03:17'!
new
	^ self lowestFrequency: 50.0! !

!Envelope2 class methodsFor: 'instance creation' stamp: 'len 5/28/2000 05:42'!
new
	^ super new initialize! !

!FM4Op class methodsFor: 'instance creation' stamp: 'len 8/27/2000 00:20'!
new
	^ super new initialize! !

!Filter class methodsFor: 'instance creation' stamp: 'len 5/28/2000 05:07'!
new
	^ super new initialize! !

!Flute class methodsFor: 'instance creation' stamp: 'len 5/29/2000 20:18'!
new
	^ self lowestFrequency: 50.0! !

!JetTable class methodsFor: 'instance creation' stamp: 'len 5/28/2000 16:03'!
new
	^ super new initialize! !

!LipFilter class methodsFor: 'instance creation' stamp: 'len 5/28/2000 05:37'!
new
	^ super new initialize! !

!Modal4 class methodsFor: 'instance creation' stamp: 'len 5/28/2000 23:43'!
new
	^ super new initialize! !

!Noise class methodsFor: 'instance creation' stamp: 'len 5/28/2000 04:12'!
new
	^ super new initialize! !

!PluckedString class methodsFor: 'instance creation' stamp: 'len 6/3/2000 21:33'!
new
	^ self lowestFrequency: 50.0! !

!ReedTable class methodsFor: 'instance creation' stamp: 'len 5/28/2000 20:28'!
new
	^ super new initialize! !

!Sitar class methodsFor: 'instance creation' stamp: 'len 9/3/2000 03:00'!
new
	^ self lowestFrequency: 50.0! !

!WvIn class methodsFor: 'instance creation' stamp: 'len 5/28/2000 22:21'!
new
	^ super new initialize! !

!Filter class methodsFor: 'instance creation' stamp: 'len 5/28/2000 03:42'!
new: anInteger
	^ super new initialize: anInteger! !

!Clarinet methodsFor: 'accessing' stamp: 'len 5/29/2000 20:51'!
noiseLevel: aNumber
	noiseGain := aNumber * 0.4! !

!Flute methodsFor: 'accessing' stamp: 'len 5/29/2000 20:53'!
noiseLevel: aNumber
	noiseGain := aNumber * 0.4! !

!WvIn methodsFor: 'accessing' stamp: 'len 5/28/2000 20:43'!
normalize
	self normalize: 1.0! !

!WvIn methodsFor: 'accessing' stamp: 'len 5/28/2000 20:45'!
normalize: newPeak
	"Normalize all channels equally by the greatest magnitude in all of data."
	| max |
	max := data inject: 0.0 into: [ :result :each | result max: each abs].
	max > 0.0 ifTrue: [data *= (1.0 / max * newPeak)]! !

!OnePole methodsFor: 'private' stamp: 'len 6/3/2000 20:28'!
normalizeGain
	"Normalize gain to 1.0 max."
	coefficient > 0.0
		ifTrue: [sgain := 1.0 - coefficient * gain]
		ifFalse: [sgain := 1.0 + coefficient * gain]! !

!OneZero methodsFor: 'private' stamp: 'len 6/3/2000 20:21'!
normalizeGain
	"Normalize gain to 1.0 max."
	coefficient > 0.0
		ifTrue: [sgain := gain / (1.0 + coefficient)]
		ifFalse: [sgain := gain / (1.0 - coefficient)]! !

!BowedString methodsFor: 'events' stamp: 'len 5/29/2000 05:09'!
noteOff: amp
	self stopBowing: 1.0 - amp * 0.005! !

!Brass methodsFor: 'events' stamp: 'len 5/29/2000 20:38'!
noteOff: amp
	self stopBlowing: amp * 0.005! !

!Clarinet methodsFor: 'events' stamp: 'len 5/29/2000 19:00'!
noteOff: amp
	self stopBlowing: amp * 0.01! !

!Drone methodsFor: 'events' stamp: 'len 9/3/2000 03:15'!
noteOff: amp
	loopGain := 1.0 - amp! !

!FM4Op methodsFor: 'events' stamp: 'len 8/26/2000 22:21'!
noteOff: amp
	self keyOff! !

!Flute methodsFor: 'events' stamp: 'len 6/3/2000 17:21'!
noteOff: amp
	self stopBlowing: amp * 0.02! !

!Instrument methodsFor: 'events' stamp: 'len 5/28/2000 16:22'!
noteOff: amp
	self subclassResponsibility! !

!PluckedString methodsFor: 'events' stamp: 'len 6/3/2000 23:46'!
noteOff: amp
	loopGain := 1.0 - amp * 0.5! !

!Sitar methodsFor: 'events' stamp: 'len 9/3/2000 02:53'!
noteOff: amp
	loopGain := 1.0 - amp! !

!BeeThree methodsFor: 'events' stamp: 'len 9/2/2000 21:39'!
noteOn: freq amplitude: amp
	1 to: 4 do: [ :i | gains at: i put: amp * (Gains at: (#(96 96 100 96) at: i))].
	self frequency: freq.
	self keyOn! !

!BowedString methodsFor: 'events' stamp: 'len 5/29/2000 05:08'!
noteOn: freq amplitude: amp
	self startBowing: amp rate: amp * 0.001.
	self frequency: freq! !

!Brass methodsFor: 'events' stamp: 'spfa 11/13/2017 13:50'!
noteOn: freq amplitude: amp
	self frequency: freq.
	self startBlowing: amp rate: amp * 0.001! !

!Clarinet methodsFor: 'events' stamp: 'len 5/29/2000 19:23'!
noteOn: freq amplitude: amp
	self frequency: freq.
	self startBlowing: amp * 0.30 + 0.55 rate: amp * 0.005.
	outputGain := amp + 0.001! !

!Drone methodsFor: 'events' stamp: 'len 9/3/2000 03:15'!
noteOn: freq amplitude: amp
	self frequency: freq.
	self pluck: amp! !

!Flute methodsFor: 'events' stamp: 'len 6/3/2000 17:20'!
noteOn: freq amplitude: amp
	self frequency: freq.
	self startBlowing: amp * 0.20 + 1.1 rate: amp * 0.02.
	outputGain := amp + 0.001! !

!Instrument methodsFor: 'events' stamp: 'len 9/2/2000 17:45'!
noteOn: freq amplitude: amp
	self subclassResponsibility! !

!Mandolin methodsFor: 'events' stamp: 'len 6/4/2000 00:13'!
noteOn: freq amplitude: amp
	self frequency: freq; pluck: amp! !

!Modal4 methodsFor: 'events' stamp: 'len 5/28/2000 23:34'!
noteOn: freq amplitude: amp
	self strike: amp; frequency: freq! !

!Rhodey methodsFor: 'events' stamp: 'len 8/26/2000 23:59'!
noteOn: freq amplitude: amp
	1 to: 4 do: [ :i | gains at: i put: amp * (Gains at: (#(100 91 100 68) at: i))].
	self frequency: freq.
	self keyOn! !

!Sitar methodsFor: 'events' stamp: 'len 9/3/2000 02:53'!
noteOn: freq amplitude: amp
	self frequency: freq.
	self pluck: amp.
	amPluck := 0.05 * amp! !

!TubularBell methodsFor: 'events' stamp: 'len 8/27/2000 03:06'!
noteOn: freq amplitude: amp
	1 to: 4 do: [ :i | gains at: i put: amp * (Gains at: (#(95 77 100 72) at: i))].
	self frequency: freq.
	self keyOn! !

!Wurley methodsFor: 'events' stamp: 'len 8/27/2000 02:49'!
noteOn: freq amplitude: amp
	1 to: 4 do: [ :i | gains at: i put: amp * (Gains at: (#(100 83 83 69) at: i))].
	self frequency: freq.
	self keyOn! !

!BowTable methodsFor: 'accessing' stamp: 'len 5/28/2000 20:31'!
offset: aNumber
	offset := aNumber! !

!ReedTable methodsFor: 'accessing' stamp: 'len 5/28/2000 20:23'!
offset: aNumber
	"Offset is a bias, related to reed rest position."
	offset := aNumber! !

!MonoWvIn class methodsFor: 'instance creation' stamp: 'len 5/28/2000 22:24'!
oneshotFromFileNamed: fileName
	^ self fromFileNamed: fileName looping: false! !

!Instrument methodsFor: 'examples-scores' stamp: 'len 9/2/2000 21:48'!
organsScore
	"
	BeeThree new organsScore play
	"
	^ self soundForScore: (self scoreFrom:
'NoteOn          0.000327 2 68 64
NoteOn          0.011439 2 72 60
NoteOn          0.100661 2 69 58
NoteOff         0.022910 2 68 0
NoteOff         0.087179 2 69 0
NoteOff         0.002768 2 72 0
NoteOn          0.146276 2 74 60
NoteOn          0.007877 2 70 73
NoteOff         0.065823 2 74 0
NoteOff         0.034091 2 70 0
NoteOn          0.071562 2 65 42
NoteOff         0.095505 2 65 0
NoteOn          0.117222 2 72 36
NoteOn          0.003568 2 75 57
NoteOff         0.867934 2 72 0
NoteOff         0.016747 2 75 0
NoteOn          0.001292 2 70 66
NoteOn          0.016806 2 74 41
NoteOff         0.903721 2 70 0
NoteOn          0.002269 2 71 60
NoteOff         0.002452 2 74 0
NoteOff         0.024367 2 71 0
NoteOn          0.573769 2 71 71
NoteOn          0.071125 2 72 47
NoteOff         0.017603 2 71 0
NoteOn          0.099531 2 77 63
NoteOff         0.005133 2 72 0
NoteOn          0.002825 2 75 57
NoteOff         0.051047 2 77 0
NoteOn          0.062443 2 72 42
NoteOff         0.003421 2 75 0
NoteOn          0.004190 2 73 22
NoteOff         0.032476 2 73 0
NoteOff         0.003357 2 72 0
NoteOn          0.003412 2 71 51
NoteOff         0.082169 2 71 0
NoteOn          0.030527 2 70 64
NoteOff         0.068936 2 70 0
NoteOn          0.002836 2 68 63
NoteOff         0.069395 2 68 0
NoteOn          0.024967 2 65 52
NoteOff         0.083696 2 65 0
NoteOn          0.027784 2 63 69
NoteOff         0.102489 2 63 0
NoteOn          0.048174 2 60 61
NoteOff         0.094914 2 60 0
NoteOn          0.076034 2 58 62
NoteOff         0.080772 2 58 0
NoteOn          0.107826 2 56 73
NoteOff         0.114325 2 56 0
NoteOn          0.159665 2 53 71
NoteOff         0.094385 2 53 0
NoteOn          0.218823 2 56 82
NoteOff         0.396073 2 56 0
NoteOn          0.016601 2 53 79
NoteOff         0.590675 2 53 0
NoteOn          0.013945 2 41 61
NoteOn          0.003797 2 53 48
NoteOn          0.749734 2 57 69
NoteOn          0.006420 2 63 69
NoteOff         0.004025 2 53 0
NoteOn          0.001033 2 59 71
NoteOff         0.183718 2 59 0
NoteOff         0.354573 2 63 0
NoteOff         0.014193 2 57 0
NoteOff         0.008219 2 41 0')! !

!Instrument methodsFor: 'examples-scores' stamp: 'len 9/2/2000 20:54'!
picturesScore
	"
	Brass new picturesScore play
	"
	^ self soundForScore: (self scoreFrom:
'NoteOn          0.000000 1 72 127.000000
NoteOff         0.540000 1 72 63.500000
NoteOn          0.060000 1 70 127.000000
NoteOff         0.540000 1 70 63.500000
NoteOn          0.060000 1 75 127.000000
NoteOff         0.540000 1 75 63.500000
NoteOn          0.060000 1 77 127.000000
NoteOff         0.270023 1 77 63.500000
NoteOn          0.030023 1 70 127.000000
LipTension	0.000000 1  2 96.000000
NoteOff         0.299728 1 70 63.500000
NoteOn          0.000317 1 79 127.000000
NoteOff         0.540000 1 79 63.500000
NoteOn          0.060000 1 77 127.000000
NoteOff         0.270023 1 77 63.500000
NoteOn          0.030023 1 70 127.000000
LipTension   0.000000 1  2 96.000000
NoteOff         0.299728 1 70 63.500000
NoteOn          0.000317 1 79 127.000000
NoteOff         0.540000 1 79 63.500000
NoteOn          0.060000 1 75 127.000000
NoteOff         0.540000 1 75 63.500000
NoteOn          0.060000 1 77 127.000000
NoteOff         0.540000 1 77 63.500000
NoteOn          0.060000 1 72 127.000000
NoteOff         0.540000 1 72 63.500000
NoteOn          0.060000 1 70 127.000000
NoteOff         0.540000 1 70 63.500000
NoteOff         0.060000 1 70 63.500000')! !

!Drone methodsFor: 'generation' stamp: 'len 9/3/2000 03:09'!
pluck: amplitude
	envelope keyOn! !

!Mandolin methodsFor: 'generation' stamp: 'len 6/4/2000 00:11'!
pluck: amplitude
	"The pluck may be longer than the string length, so we just reset the wave and add in the pluck in the tick method."
	(waves at: mic) reset.
	pluckAmplitude := amplitude.
	"Set pick position which puts zeroes at pos*length."
	combDelay delay: 0.5 * pluckPosition * lastLength.
	dampTime := lastLength.
	waveDone := false! !

!Sitar methodsFor: 'generation' stamp: 'len 9/3/2000 02:52'!
pluck: amplitude
	envelope keyOn! !

!Mandolin methodsFor: 'generation' stamp: 'len 6/4/2000 00:12'!
pluck: amplitude position: position
	pluckPosition := position.
	self pluck: amplitude! !

!PluckedString methodsFor: 'accessing' stamp: 'len 6/3/2000 23:44'!
pluckPosition: aNumber
	pluckPosition := aNumber! !

!BiQuad methodsFor: 'accessing' stamp: 'len 5/28/2000 03:37'!
poleCoeffs: aCollection
	p0 := aCollection first.
	p1 := aCollection second! !

!Instrument methodsFor: 'accessing' stamp: 'len 9/2/2000 19:24'!
range
	"Answer the rango of the receiver."
	^ 0 to: 12543.85395141598! !

!WvIn methodsFor: 'accessing' stamp: 'len 6/3/2000 18:14'!
rate
	^ rate! !

!Envelope2 methodsFor: 'accessing' stamp: 'len 5/29/2000 00:59'!
rate: aNumber
	rate := aNumber abs! !

!WvIn methodsFor: 'accessing' stamp: 'len 5/28/2000 20:47'!
rate: aNumber
	rate := aNumber.
	interpolate := rate fractionPart > 0.0! !

!FM4Op methodsFor: 'accessing' stamp: 'len 8/26/2000 23:49'!
ratios: aCollection
	aCollection withIndexDo: [ :each :index | self set: index ratio: each]! !

!SynthesisInfo methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:17'!
readmeText

	^ 'Change Set:		STK2
Date:			2 October 2000
Author:			Luciano

This is the almost complete port of the Synthesis ToolKit to Squeak. There are several examples in the ''examples-scores'' and ''examples-scales'' method categories of Instrument (the method comments have some shortcuts).

Known bugs: some instruments sound too loud and some of them too quiet.

Methods that would help a lot if primitivized: DLineL|tick:, BiQuad|tick:, MonoWvIn|informTick, Noise|tick, LipFilter|tick:bore:, BowTable|lookup:, DLineA|tick:, OneZero|tick:.

The instrument hierarchy looks like this:
		Instrument
			BowedString
			Brass
			Clarinet
			Drone
			FM4Op
				FM4Alg5
					Rhodey
					TubularBell
					Wurley
				FM4Alg8
					BeeThree
			Flute
			Modal4
				AgogoBell
				Marimba
				Vibraphone
			PluckedString
				Mandolin
			Shaker
			Sitar'! !

!Clarinet methodsFor: 'accessing' stamp: 'len 5/29/2000 20:50'!
reedStiffness: aNumber
	reedTable slope: 0.26 * aNumber - 0.44! !

!ADSR methodsFor: 'accessing' stamp: 'len 5/29/2000 05:20'!
releaseRate: aNumber
	releaseRate := aNumber abs! !

!ADSR methodsFor: 'private' stamp: 'len 5/28/2000 06:06'!
releaseState
	^ 3! !

!ADSR methodsFor: 'generation-private' stamp: 'len 6/3/2000 21:14'!
releaseTick
	value := value - releaseRate.
	value <= 0.0
		ifTrue: [value := 0.0.
				state := 4].
	^ value! !

!ADSR methodsFor: 'accessing' stamp: 'len 5/29/2000 02:32'!
releaseTime: aNumber
	self releaseRate: 1.0 / self samplingRate / aNumber! !

!MonoWvIn methodsFor: 'generation' stamp: 'len 8/27/2000 01:37'!
reset
	finished := false.
	time := 0.0.
	lastOutput := 0.0! !

!WvIn methodsFor: 'generation' stamp: 'len 5/28/2000 20:44'!
reset
	finished := false.
	time := 0.0.
	lastOutput atAllPut: 0.0! !

!Instrument methodsFor: 'examples-scores' stamp: 'len 9/2/2000 21:00'!
ridersonScore
	"
	Mandolin new ridersonScore play
	"
	^ self soundForScore: (self scoreFrom:
'StringDetune   0.000000 1  1 50.000000
NoteOn          0.000000 1 60 114.299997
NoteOff         0.480045 1 60 88.899998
NoteOn          0.120045 1 60 76.200003
NoteOff         0.150023 1 60 63.500000
NoteOn          0.150023 1 62 101.600002
NoteOff         0.720000 1 62 88.899998
NoteOn          0.180000 1 62 76.200003
NoteOff         0.150023 1 62 63.500000
NoteOn          0.150023 1 63 101.600002
NoteOff         0.720000 1 63 88.899998
NoteOn          0.180000 1 63 38.100002
NoteOff         0.150023 1 63 63.500000
NoteOn          0.150023 1 62 101.600002
NoteOff         0.720000 1 62 88.899998
NoteOn          0.180000 1 62 76.200003
NoteOff         0.480045 1 62 88.899998
NoteOn          0.120045 1 48 114.299997
NoteOff         0.480045 1 48 88.899998
NoteOn          0.120045 1 48 76.200003
NoteOff         0.150023 1 48 63.500000
NoteOn          0.150023 1 50 101.600002
NoteOff         0.720000 1 50 88.899998
NoteOn          0.180000 1 50 76.200003
NoteOff         0.150023 1 50 63.500000
NoteOn          0.150023 1 51 101.600002
NoteOff         0.720000 1 51 88.899998
NoteOn          0.180000 1 51 38.100002
NoteOff         0.150023 1 51 63.500000
NoteOn          0.150023 1 50 101.600002
NoteOff         0.720000 1 50 88.899998
NoteOn          0.180000 1 48 76.200003
NoteOff         0.240045 1 48 88.899998
NoteOn          0.060045 1 72 88.899998
NoteOff         0.240045 1 72 88.899998
NoteOn          0.060045 1 77 114.299997
NoteOff         0.240045 1 77 88.899998
NoteOn          0.060045 1 77 101.600002
NoteOff         0.240045 1 77 88.899998
NoteOn          0.060045 1 77 88.899998
NoteOff         0.240045 1 77 88.899998
NoteOn          0.060045 1 75 76.200003
NoteOff         0.240045 1 75 88.899998
NoteOn          0.060045 1 77 88.899998
NoteOff         0.480045 1 77 88.899998
NoteOn          0.120045 1 77 88.899998
NoteOff         0.150023 1 77 63.500000
NoteOn          0.150023 1 77 88.899998
NoteOff         0.150023 1 77 63.500000
NoteOn          0.150023 1 87 101.600002
NoteOff         0.240045 1 87 88.899998
NoteOn          0.060045 1 84 76.200003
NoteOff         0.150023 1 84 63.500000
NoteOn          0.150023 1 84 76.200003
NoteOff         0.240045 1 84 88.899998
NoteOn          0.060045 1 82 76.200003
NoteOff         0.240045 1 82 88.899998
NoteOn          0.060045 1 84 88.899998
NoteOff         0.960045 1 84 88.899998
NoteOn          0.240045 1 48 127.000000
StringDetune   0.000000 1  1 127.000000
NoteOff         1.300000 1 48 63.500000')! !

!Envelope2 methodsFor: 'accessing' stamp: 'len 5/29/2000 05:18'!
samplingRate
	^ Instrument samplingRate! !

!Filter methodsFor: 'accessing' stamp: 'len 5/28/2000 23:59'!
samplingRate
	^ Instrument samplingRate! !

!Instrument methodsFor: 'accessing' stamp: 'len 5/28/2000 23:58'!
samplingRate
	^ self class samplingRate! !

!LipFilter methodsFor: 'accessing' stamp: 'len 5/29/2000 20:59'!
samplingRate
	^ Instrument samplingRate! !

!WvIn methodsFor: 'accessing' stamp: 'len 5/30/2000 06:58'!
samplingRate
	^ Instrument samplingRate! !

!Instrument methodsFor: 'examples-private' stamp: 'len 9/2/2000 20:33'!
scoreFrom: aString
	| messages tokens delay |
	messages := OrderedCollection new.
	(aString findTokens: Character cr asString) do: [ :eachLine |
		(tokens := eachLine findTokens: ' ', Character tab asString) size > 1
			ifTrue: [delay := tokens second asNumber.
					messages add: delay -> (self scoreMessageForCommand: tokens first code: tokens third asNumber arg1: tokens fourth asNumber arg2: (tokens at: 5 ifAbsent: [tokens fourth]) asNumber)]].
	^ messages! !

!Instrument methodsFor: 'examples-private' stamp: 'len 9/3/2000 04:13'!
scoreMessageForCommand: command code: code arg1: arg1 arg2: arg2
	'NoteOn' = command ifTrue: [^ Message selector: #noteOn:amplitude: arguments: {AbstractSound pitchForMIDIKey: arg1. arg2 / 127.0}].
	'NoteOff' = command ifTrue: [^ Message selector: #noteOff: argument: arg2 / 127.0].
	(self controls includes: command asSymbol) ifTrue: [^ Message selector: #controlChange:value: arguments: {command asSymbol. arg2}].
	^ Message selector: #yourself
! !

!FM4Op methodsFor: 'accessing' stamp: 'len 8/26/2000 23:44'!
set: index gain: gain
	gains at: index put: gain! !

!FM4Op methodsFor: 'accessing' stamp: 'len 8/26/2000 23:43'!
set: index ratio: ratio
	ratios at: index put: ratio.
	(waves at: index) frequency: (ratio > 0.0 ifTrue: [frequency * ratio] ifFalse: [ratio])! !

!MonoWvIn methodsFor: 'accessing' stamp: 'len 8/27/2000 01:36'!
setChannels: n
	n = 1 ifFalse: [self error: self class name, ' can only be mono'].
	lastOutput := 0.0! !

!WvIn methodsFor: 'initialization' stamp: 'len 8/27/2000 01:28'!
setChannels: n
	channels := n.
	lastOutput := Array new: n! !

!BiQuad methodsFor: 'accessing' stamp: 'len 5/28/2000 03:37'!
setEqualGainZeros
	z1 := -1.0.
	z0 := 0.0! !

!Modal4 methodsFor: 'private' stamp: 'len 5/28/2000 23:24'!
setFilterIndex: index gain: gain
	(filters at: index) gain: gain! !

!Modal4 methodsFor: 'private' stamp: 'len 8/27/2000 03:46'!
setFilterIndex: index ratio: ratio resonance: resonance
	| temp |
	ratio * frequency < (self samplingRate / 2)
		ifTrue: [ratios at: index put: ratio]
		ifFalse: [temp := ratio.
				[temp * frequency > (self samplingRate / 2)] whileTrue: [temp := temp / 2.0].
				ratios at: index put: temp].
	resonances at: index put: resonance.
	ratio < 0
		ifTrue: [temp := ratio negated]
		ifFalse: [temp := ratio * frequency].
	(filters at: index) frequency: temp resonance: resonance! !

!Modal4 methodsFor: 'private' stamp: 'len 5/28/2000 23:47'!
setFilterIndex: index ratio: ratio resonance: resonance gain: gain
	self setFilterIndex: index ratio: ratio resonance: resonance; setFilterIndex: index gain: gain! !

!WvIn methodsFor: 'accessing' stamp: 'len 5/28/2000 20:50'!
setInterpolate: aBoolean
	interpolate := aBoolean! !

!WvIn methodsFor: 'accessing' stamp: 'len 5/28/2000 20:55'!
setLooping: aBoolean
	looping := aBoolean.
	time := 0.0.
	looping
		ifTrue: [1 to: channels do: [ :i | self at: length channel: i put: (self at: 1 channel: i)]]
		ifFalse: [1 to: channels do: [ :i | self at: length channel: i put: (self at: length - 1 channel: i)]]! !

!Instrument methodsFor: 'examples-scores' stamp: 'len 9/2/2000 20:19'!
simplgftScore
	"
	Clarinet new simplgftScore play
	"
	^ self soundForScore: (self scoreFrom:
'NoteOn          0.000000 1 60 127.000000
NoteOff         0.475011 1 60 63.500000
NoteOn          0.025034 1 65 127.000000
NoteOff         0.475011 1 65 63.500000
NoteOn          0.025034 1 65 127.000000
NoteOff         0.124989 1 65 63.500000
NoteOn          0.124989 1 67 127.000000
NoteOff         0.124989 1 67 63.500000
NoteOn          0.124989 1 69 127.000000
NoteOff         0.237506 1 69 63.500000
NoteOn          0.012517 1 65 127.000000
NoteOff         0.124989 1 65 63.500000
NoteOn          0.124989 1 69 127.000000
NoteOff         0.124989 1 69 63.500000
NoteOn          0.124989 1 70 127.000000
NoteOff         0.237506 1 70 63.500000
NoteOn          0.012517 1 72 127.000000
NoteOff         0.475011 1 72 63.500000
NoteOn          0.025034 1 72 127.000000
NoteOff         0.237506 1 72 63.500000
NoteOn          0.012517 1 70 127.000000
NoteOff         0.124989 1 70 63.500000
NoteOn          0.124989 1 69 127.000000
NoteOff         0.475011 1 69 63.500000
NoteOn          0.025034 1 79 127.000000
NoteOff         0.124989 1 79 63.500000
NoteOn          0.124989 1 77 127.000000
NoteOff         0.124989 1 77 63.500000
NoteOn          0.124989 1 79 127.000000
NoteOff         0.475011 1 79 63.500000
NoteOn          0.025034 1 79 127.000000
NoteOff         0.475011 1 79 63.500000
NoteOn          0.025034 1 81 127.000000
NoteOff         0.475011 1 81 63.500000
NoteOn          0.025034 1 81 127.000000
NoteOff         0.124989 1 81 63.500000
NoteOn          0.124989 1 79 127.000000
NoteOff         0.124989 1 79 63.500000
NoteOn          0.124989 1 77 127.000000
Modulation   0.000000 1 1 32.000000
NoteOff         0.475011 1 77 63.500000
NoteOn          0.025034 1 65 127.000000
NoteOff         0.475011 1 65 63.500000
NoteOn          0.025034 1 41 127.000000
NoteOff         0.950023 1 41 63.500000
NoteOff         0.050023 1 41 63.500000
')! !

!WvIn class methodsFor: 'examples' stamp: 'len 8/27/2000 01:43'!
sinewave
	"
	(WvIn sinewave asSampledSoundCount: 10000) play
	"
	^ MonoWvIn fromStream: (ReadStream on: #(0 0 3 36 6 71 9 106 12 139 15 171 18 199 21 225 24 248 28 11 31 25 34 35 37 39 40 38 43 30 46 16 48 251 51 222 54 185 57 140 60 86 63 22 65 205 68 122 71 28 73 179 76 63 78 191 81 51 83 154 85 244 88 66 90 129 92 179 94 214 96 235 98 241 100 231 102 206 104 165 106 108 108 35 109 201 111 94 112 225 114 84 115 181 117 3 118 64 119 107 120 131 121 137 122 124 123 92 124 41 124 226 125 137 126 28 126 156 127 8 127 97 127 166 127 215 127 245 127 255 127 245 127 215 127 166 127 97 127 8 126 156 126 28 125 137 124 226 124 41 123 92 122 124 121 137 120 131 119 107 118 64 117 3 115 181 114 84 112 225 111 94 109 201 108 35 106 108 104 165 102 206 100 231 98 241 96 235 94 214 92 179 90 129 88 66 85 244 83 154 81 51 78 191 76 63 73 179 71 28 68 122 65 205 63 22 60 86 57 140 54 185 51 222 48 251 46 16 43 30 40 38 37 39 34 35 31 25 28 11 24 248 21 225 18 199 15 171 12 139 9 106 6 71 3 36 0 0 252 220 249 185 246 150 243 117 240 85 237 57 234 31 231 8 227 245 224 231 221 221 218 217 215 218 212 226 209 240 207 5 204 34 201 71 198 116 195 170 192 234 190 51 187 134 184 228 182 77 179 193 177 65 174 205 172 102 170 12 167 190 165 127 163 77 161 42 159 21 157 15 155 25 153 50 151 91 149 148 147 221 146 55 144 162 143 31 141 172 140 75 138 253 137 192 136 149 135 125 134 119 133 132 132 164 131 215 131 30 130 119 129 228 129 100 128 248 128 159 128 90 128 41 128 11 128 1 128 11 128 41 128 90 128 159 128 248 129 100 129 228 130 119 131 30 131 215 132 164 133 132 134 119 135 125 136 149 137 192 138 253 140 75 141 172 143 31 144 162 146 55 147 221 149 148 151 91 153 50 155 25 157 15 159 21 161 42 163 77 165 127 167 190 170 12 172 102 174 205 177 65 179 193 182 77 184 228 187 134 190 51 192 234 195 170 198 116 201 71 204 34 207 5 209 240 212 226 215 218 218 217 221 221 224 231 227 245 231 8 234 31 237 57 240 85 243 117 246 150 249 185 252 220)) looping: true! !

!Brass methodsFor: 'accessing' stamp: 'len 9/2/2000 20:47'!
slideLength: aNumber
	delayLine delay: 0.5 + aNumber * slideTarget! !

!BowTable methodsFor: 'accessing' stamp: 'len 5/28/2000 20:31'!
slope: aNumber
	slope := aNumber! !

!ReedTable methodsFor: 'accessing' stamp: 'len 5/28/2000 20:23'!
slope: aNumber
	"Slope corresponds loosely to reed stiffness."
	slope := aNumber! !

!Instrument methodsFor: 'examples-private' stamp: 'len 8/27/2000 04:58'!
soundForEvents: aCollection
	| time tick endTime output events |
	time := 0.0.
	tick := 1.0 / self samplingRate.
	endTime := aCollection last endTime + 0.5.
	output := WriteStream on: (SoundBuffer new: (endTime * self samplingRate) truncated).
	events := aCollection readStream.
	[time > endTime]
		whileFalse: [time > events peek time ifTrue: [self playEvent: events next].
					output nextPut: (((self tick * 32000) truncated max: -32767) min: 32767).
					time := time + tick].
	^ (LoopedSampledSound unloopedSamples: output contents pitch: 440.0 samplingRate: self samplingRate) duration: endTime; loudness: 1.0! !

!Instrument methodsFor: 'examples-private' stamp: 'len 9/3/2000 04:33'!
soundForScore: aCollection
	| time endTime events samplingRate buffer lastEventTime |
	time := 0.0.
	samplingRate := self samplingRate.
	endTime := (aCollection inject: 0 into: [ :sum :each | sum + each key]) + 0.5.
	buffer := SoundBuffer new: (endTime * self samplingRate) truncated.
	events := ReadStream on: aCollection.
	lastEventTime := time.
	1 to: buffer size do: [ :i |
		[events atEnd not and: [time - lastEventTime >= events peek key]] whileTrue: [events next value sentTo: self. lastEventTime := time].
		buffer at: i put: (((self tick * 32000) truncated max: -32767) min: 32767).
		time := i - 1 / samplingRate].
	^ (LoopedSampledSound unloopedSamples: buffer pitch: 440.0 samplingRate: self samplingRate) duration: endTime; loudness: 1.0! !

!Instrument methodsFor: 'examples-scores' stamp: 'len 10/2/2000 09:22'!
spainScore
	"Chick Corea's!!"
	"
	Rhodey new spainScore play
	Wurley new spainScore play
	BeeThree new spainScore play
	"
	^ self soundForScore: (self scoreFrom:
'NoteOn          0.000000 1 48 88.899998
NoteOff         0.416009 1 48 63.500000
NoteOn          0.104036 1 53 101.600002
NoteOff         0.312018 1 53 63.500000
NoteOn          0.078005 1 56 63.500000
NoteOn          0.130023 1 55 101.600002
NoteOn          0.260000 1 51 76.200003
NoteOn          0.130023 1 48 38.100002
NoteOn          0.130023 1 53 101.600002
NoteOn          0.520000 1 58 127.000000
NoteOff         0.312018 1 58 63.500000
NoteOn          0.078005 1 63 76.200003
NoteOn          0.130023 1 62 114.299997
NoteOff         0.416009 1 62 63.500000
NoteOn          0.104036 1 58 127.000000
NoteOn          0.130023 1 60 50.800001
NoteOn          0.260000 1 56 88.899998
NoteOn          0.260000 1 56 63.500000
NoteOn          0.130023 1 63 76.200003
NoteOn          0.260000 1 41 127.000000
ModWheel   0.000000 1  1 127.000000
NoteOff         1.950023 1 41 63.500000')! !

!Brass methodsFor: 'generation' stamp: 'len 5/29/2000 20:36'!
startBlowing: amp rate: rate
	adsr attackRate: rate; keyOn.
	maxPressure := amp! !

!Clarinet methodsFor: 'generation' stamp: 'len 5/29/2000 18:58'!
startBlowing: amp rate: rate
	envelope rate: rate; target: amp! !

!Flute methodsFor: 'generation' stamp: 'len 5/29/2000 19:44'!
startBlowing: amp rate: rate
	adsr attackRate: rate; keyOn.
	maxPressure := amp / 0.8! !

!AgogoBell methodsFor: 'accessing' stamp: 'len 8/28/2000 20:33'!
stickHardness: hardness
	stickHardness := hardness.
	wave rate: 8.0 * hardness + 3.0.
	masterGain := 1.0! !

!Marimba methodsFor: 'accessing' stamp: 'len 5/29/2000 02:47'!
stickHardness: hardness
	stickHardness := hardness.
	wave rate: 0.25 * (4.0 raisedTo: stickHardness).
	masterGain := 1.8 * stickHardness + 0.1! !

!Vibraphone methodsFor: 'accessing' stamp: 'len 5/28/2000 23:49'!
stickHardness: hardness
	wave rate: 2.0 + (22.66 * hardness).
	masterGain := 0.2 + (hardness * 1.6)! !

!Brass methodsFor: 'generation' stamp: 'len 5/29/2000 20:36'!
stopBlowing: rate
	adsr releaseRate: rate; keyOff! !

!Clarinet methodsFor: 'generation' stamp: 'len 5/29/2000 18:58'!
stopBlowing: rate
	envelope rate: rate; target: 0.0! !

!Flute methodsFor: 'generation' stamp: 'len 5/29/2000 19:45'!
stopBlowing: rate
	adsr releaseRate: rate; keyOff! !

!BowedString methodsFor: 'generation' stamp: 'len 5/29/2000 05:08'!
stopBowing: rate
	adsr rate: rate; keyOff! !

!Marimba methodsFor: 'generation' stamp: 'len 5/30/2000 07:30'!
strike: amp
	| r |
	multiStrike := 0.
	r := 31 atRandom.
	r < 3 ifTrue: [multiStrike := 1].
	r < 2 ifTrue: [multiStrike := 2].
	super strike: amp! !

!Modal4 methodsFor: 'generation' stamp: 'len 8/27/2000 03:46'!
strike: amplitude
	| freq |
	envelope rate: 1.0; target: amplitude.
	onepole coefficient: 1.0 - amplitude.
	envelope tick.
	wave reset.
	1 to: 4 do: [ :i |
		(ratios at: i) < 0.0
			ifTrue: [freq := (ratios at: i) negated]
			ifFalse: [freq := (ratios at: i) * frequency].
		(filters at: i) frequency: freq resonance: (resonances at: i)]! !

!AgogoBell methodsFor: 'accessing' stamp: 'len 8/28/2000 20:40'!
strikePosition: position
	| temp |
	temp := position * Float pi.
	strikePosition := position.
	self setFilterIndex: 1 gain: (0.7 * temp) sin * 0.08.
	self setFilterIndex: 2 gain: (5.0 * temp + 0.1) sin * 0.07.
	self setFilterIndex: 3 gain: (7.0 * temp + 0.2) sin * 0.04! !

!Marimba methodsFor: 'accessing' stamp: 'len 5/30/2000 07:55'!
strikePosition: position
	| temp2 temp |
	strikePosition := position.
	temp2 := position * Float pi.
	temp := temp2 sin.
	self setFilterIndex: 1 gain: 0.12 * temp.
	temp := (3.9 * temp2 + 0.05) sin.
	self setFilterIndex: 2 gain: -0.03 * temp.
	temp := (11 * temp2 - 0.05) sin.
	self setFilterIndex: 3 gain: 0.11 * temp! !

!Vibraphone methodsFor: 'accessing' stamp: 'len 5/30/2000 08:00'!
strikePosition: position
	| temp2 temp |
	strikePosition := position.
	temp2 := position * Float pi.
	temp := (strikePosition * Float pi) sin.
	self setFilterIndex: 1 gain: 0.025 * temp.
	temp := (2.01 * temp2 + 0.1) sin.
	self setFilterIndex: 2 gain: 0.015 * temp.
	temp := (3.95 * temp2) sin.
	self setFilterIndex: 3 gain: 0.015 * temp! !

!SubNoise methodsFor: 'accessing' stamp: 'len 5/28/2000 04:21'!
subSample: n
	lastOutput := 0.0.
	howOften := n - 1.
	counter := n - 1! !

!ADSR methodsFor: 'accessing' stamp: 'len 6/3/2000 21:07'!
sustainLevel: aNumber
	sustainLevel := aNumber max: 0.0! !

!ADSR methodsFor: 'private' stamp: 'len 5/28/2000 06:06'!
sustainState
	^ 2! !

!ADSR methodsFor: 'accessing' stamp: 'len 5/28/2000 05:58'!
target: aNumber
	target := aNumber.
	value < target
		ifTrue: [state := self attackState.
				self sustainLevel: target.
				rate := attackRate].
	value > target
		ifTrue: [self sustainLevel: target.
				state := self decayState.
				rate := decayRate]! !

!Envelope2 methodsFor: 'accessing' stamp: 'len 5/28/2000 05:45'!
target: aNumber
	target := aNumber.
	value ~= target ifTrue: [state := 1]! !

!ADSR methodsFor: 'generation' stamp: 'len 9/2/2000 22:45'!
tick
	self isAttacking ifTrue: [^ self attackTick].
	self isDecaying ifTrue: [^ self decayTick].
	self isReleasing ifTrue: [^ self releaseTick].
	^ value! !

!BeeThree methodsFor: 'generation' stamp: 'len 9/2/2000 21:36'!
tick
	| temp |
	modulationDepth > 0.0
		ifTrue: [temp := modulationDepth * vibWave tick * 0.1 + 1.0.
				waves with: ratios do: [ :wave :ratio | wave frequency: frequency * ratio * temp]].
	^ super tick! !

!BowedString methodsFor: 'generation' stamp: 'len 5/29/2000 05:15'!
tick
	| bowVelocity bridgeRefl nutRefl stringVel velDiff newVel |
	bowVelocity := maxVelocity * adsr tick.
	bridgeRefl := -1.0 * (reflFilt tick: bridgeDelay lastOut). "Bridge reflection."
	nutRefl := -1.0 * neckDelay lastOut. "Nut reflection."
	stringVel := bridgeRefl + nutRefl. "Sum is string velocity."
	velDiff := bowVelocity - stringVel. "Differential velocity."
	newVel := velDiff * (bowTable lookup: velDiff). "Non-linear Bow Function."

	"Do string propagations:"
	neckDelay tick: bridgeRefl + newVel.
	bridgeDelay tick: nutRefl + newVel.

	vibrGain > 0
		ifTrue: [neckDelay delay: 1.0 - betaRatio + (vibrGain * vibr tick) * baseDelay].

	^ lastOutput := bodyFilt tick: bridgeDelay lastOut! !

!Brass methodsFor: 'generation' stamp: 'len 5/29/2000 20:40'!
tick
	| breathPressure |
	breathPressure := maxPressure * adsr tick.
	breathPressure := vibrGain * vibr tick + breathPressure.
	^ lastOutput := delayLine tick: (dcBlock tick: (lipFilter tick: 0.3 * breathPressure bore: 0.85 * delayLine lastOut))! !

!Clarinet methodsFor: 'generation' stamp: 'len 5/29/2000 19:26'!
tick
	| breathPressure pressureDiff |
	breathPressure := envelope tick.
	breathPressure := breathPressure * noiseGain * noise tick + breathPressure.
	breathPressure := vibrGain * vibr tick + breathPressure.

	"Differential pressure of reflected and mouth"
	pressureDiff := filter tick: delayLine lastOut.
	pressureDiff := pressureDiff * -0.95 - breathPressure.

	"Perform scattering in economical way"
	lastOutput := delayLine tick: pressureDiff * (reedTable lookup: pressureDiff) + breathPressure.
	^ lastOutput := lastOutput * outputGain! !

!Drone methodsFor: 'generation' stamp: 'len 9/3/2000 03:59'!
tick
	self flag: #hack.
	^ lastOutput := (delayLine tick: 0.005 * envelope tick * noise tick + (loopFilter tick: delayLine lastOut * loopGain)) * 3! !

!Envelope2 methodsFor: 'generation' stamp: 'len 6/3/2000 20:42'!
tick
	state = 0 ifTrue: [^ value].
	target > value
		ifTrue: [value := value + rate.
				value >= target ifTrue: [value := target. state := 0]]
		ifFalse: [value := value - rate.
				value <= target ifTrue: [value := target. state := 0]].
	^ value! !

!FM4Alg8 methodsFor: 'generation' stamp: 'len 9/2/2000 21:29'!
tick
	| sample |
	(waves at: 4) addPhaseOffset: twozero lastOut.
	sample := control1 * 2.0 * (gains at: 4) * (adsr at: 4) tick * (waves at: 4) tick.
	twozero tick: sample.
	sample := control2 * 2.0 * (gains at: 3) * (adsr at: 3) tick * (waves at: 3) tick + sample.
	sample := (gains at: 2) * (adsr at: 2) tick * (waves at: 2) tick + sample.
	sample := (gains at: 1) * (adsr at: 1) tick * (waves at: 1) tick + sample.
	^ lastOutput := sample * 0.125! !

!Flute methodsFor: 'generation' stamp: 'len 5/29/2000 20:02'!
tick
	| breathPressure randPressure temp pressureDiff |
	breathPressure := maxPressure * adsr tick.
	randPressure := noiseGain * noise tick. "Random deviation"
	randPressure := vibrGain * vibr tick + randPressure. "+ breath vibrato"
	randPressure := randPressure * breathPressure. "all scaled by breath pressure."

	temp := filter tick: boreDelay lastOut.
	temp := dcBlock tick: temp. "Block DC on reflection"

	pressureDiff := breathPressure + randPressure - (jetReflection * temp). "Breath pressure - reflected"
	pressureDiff := jetDelay tick: pressureDiff. "Jet delay line"
	pressureDiff := (jetTable lookup: pressureDiff) + (endReflection * temp). "Non-linear jet + reflected"

	lastOutput := 0.3 * (boreDelay tick: pressureDiff). "Bore delay and 'bell' filter."
	^ lastOutput := lastOutput * outputGain! !

!Instrument methodsFor: 'generation' stamp: 'len 5/30/2000 06:44'!
tick
	^ self subclassResponsibility! !

!Mandolin methodsFor: 'generation' stamp: 'len 6/4/2000 00:33'!
tick
	| excitation delayGain |
	excitation := 0.0.
	waveDone
		ifFalse: [waveDone := (waves at: mic) informTick.
				excitation := (waves at: mic) lastOut * pluckAmplitude. "scaled pluck excitation"
				excitation := combDelay tick: excitation. "with comb filtering"].
	dampTime >= 0
		ifTrue: [dampTime := dampTime - 1. "Damping hack to help avoid overflow on replucking."
				delayGain := 0.7]
		ifFalse: [delayGain := loopGain]. "No damping after first period."

	lastOutput := delayLine tick: (filter tick: delayLine lastOut * delayGain + excitation).
	lastOutput := (delayLine2 tick: (filter2 tick: delayLine2 lastOut * delayGain + excitation)) + lastOutput.

	^ lastOutput := lastOutput * 0.3 / 32768.0! !

!Marimba methodsFor: 'generation' stamp: 'len 5/29/2000 03:05'!
tick
	(multiStrike > 0 and: [wave isFinished]) ifTrue: [wave reset. multiStrike := multiStrike - 1].
	^ super tick! !

!Modal4 methodsFor: 'generation' stamp: 'len 5/30/2000 08:18'!
tick
	| temp temp2 |
	self flag: #hack.
	temp := masterGain * (onepole tick: wave tick * envelope tick).
	temp2 := 0.0.
	filters do: [ :each | temp2 := temp2 + (each tick: temp)].
	temp2 := temp2 - (temp2 * directGain) + (directGain * temp).
	vibrGain ~= 0
		ifTrue: [temp := 1.0 + (vibr tick * vibrGain). "Calculate AM and apply to mester out"
				temp2 := temp * temp2].
	^ lastOutput := temp2 * 2.0 * 4.0 "WARNING!! OUTPUT*4!! THIS IS A HACK"! !

!Noise methodsFor: 'generation' stamp: 'len 8/28/2000 20:50'!
tick
	seed := (seed * 1309) + 13849 bitAnd: 65535.
	^ lastOutput := seed / 65535.0 - 0.5! !

!Sitar methodsFor: 'generation' stamp: 'len 9/3/2000 03:00'!
tick
	| sample |
	(sample := delayLine lastOut) abs > 1.0
		ifTrue: [loopGain := 0.1.
				self noteOff: 0.9.
				delayLine delay: (delay := delayTarget)].
	sample := sample * loopGain.
	(delayTarget - delay) abs > 0.001
		ifTrue: [delayLine delay: (delay := delay * (delayTarget < delay ifTrue: [0.99999] ifFalse: [1.00001]))].
	^ lastOutput := delayLine tick: amPluck * envelope tick * noise tick + (loopFilter tick: sample)! !

!SubNoise methodsFor: 'generation' stamp: 'len 5/28/2000 04:23'!
tick
	counter <= 0
		ifTrue: [counter := howOften.
				super tick]
		ifFalse: [counter := counter - 1].
	^ self lastOut! !

!WvIn methodsFor: 'generation' stamp: 'len 5/28/2000 22:15'!
tick
	self informTick.
	^ self lastOut! !

!Amp methodsFor: 'as yet unclassified' stamp: 'spfa 1/18/2022 15:33'!
tick: sample
	lastOutput := sample * gain.
	input := sample.
	^ lastOutput! !

!BowTable methodsFor: 'generation' stamp: 'len 8/27/2000 05:25'!
tick: sample
	"Perform Table Lookup. sample is differential string vs. bow velocity."
	| input |
	input := sample + offset * slope. "add bias to sample and scale it."
	lastOutput := input abs + 0.75. "bwlow min delta, fiction = 1."
	lastOutput := (lastOutput ln * -4.0) exp.
	lastOutput > 1.0 ifTrue: [lastOutput := 1.0]. "maximum friction is 1."
	^ lastOutput! !

!DCBlock methodsFor: 'generation' stamp: 'len 6/3/2000 21:21'!
tick: sample
	lastOutput := 0.99 * lastOutput + sample - input.
	input := sample.
	^ lastOutput! !

!DLineA methodsFor: 'generation' stamp: 'len 8/27/2000 05:49'!
tick: sample
	| temp |
	inputs at: inPoint put: sample.
	inPoint := inPoint \\ length + 1.
	temp := inputs at: outPoint.
	outPoint := outPoint \\ length + 1.
	lastOutput := -1.0 * coefficient * lastOutput.
	lastOutput := coefficient * temp + lastIn + lastOutput.
	lastIn := temp.
	^ lastOutput! !

!DLineL methodsFor: 'generation' stamp: 'len 8/27/2000 05:49'!
tick: sample
	inputs at: inPoint put: sample.
	inPoint := inPoint \\ length + 1.
	lastOutput := (inputs at: outPoint) * (1.0 - alpha).
	(outPoint := outPoint + 1) <= length
		ifTrue: [lastOutput := (inputs at: outPoint) * alpha + lastOutput]
		ifFalse: [lastOutput := (inputs at: 1) * alpha + lastOutput.
				outPoint := outPoint - length].
	^ lastOutput! !

!DLineN methodsFor: 'generation' stamp: 'len 5/28/2000 03:50'!
tick: sample
	inputs at: inPoint put: sample.
	inPoint := inPoint + 1.
	inPoint > length ifTrue: [inPoint := inPoint - length].
	lastOutput := inputs at: outPoint.
	outPoint := outPoint + 1.
	outPoint > length ifTrue: [outPoint := outPoint - length].
	^ lastOutput! !

!Filter methodsFor: 'generation' stamp: 'len 5/28/2000 04:48'!
tick: sample
	^ self subclassResponsibility! !

!OnePole methodsFor: 'generation' stamp: 'len 6/3/2000 21:04'!
tick: sample
	"Perform filter operation."
	^ lastOutput := sgain * sample + (coefficient * lastOutput)! !

!OneZero methodsFor: 'generation' stamp: 'len 6/3/2000 20:21'!
tick: sample
	| temp |
	temp := sgain * sample.
	lastOutput := input * coefficient + temp.
	input := temp.
	^ lastOutput! !

!ReedTable methodsFor: 'generation' stamp: 'len 5/28/2000 20:27'!
tick: deltaP
	"Perform 'Table Lookup' by direct clipped linear function calculation.
	deltaP is differential reed pressure."

	lastOutput := slope * deltaP + offset. "compute basic non-linearity."
	lastOutput > 1.0 ifTrue: [lastOutput := 1.0]. "if other way, reed slams shut."
	lastOutput < -1.0 ifTrue: [lastOutput := -1.0]. "if all the way open, acts like open end."
	^ lastOutput! !

!TwoPole methodsFor: 'generation' stamp: 'len 5/28/2000 05:16'!
tick: sample
	| temp |
	temp := sample * gain.
	temp := p0 * (outputs at: 1) + temp.
	temp := p1 * (outputs at: 2) + temp.
	outputs at: 2 put: (outputs at: 1).
	^ lastOutput := outputs at: 1 put: temp! !

!TwoZero methodsFor: 'generation' stamp: 'len 8/27/2000 05:32'!
tick: sample
	lastOutput := z0 * (inputs at: 1) + (z1 * (inputs at: 2)).
	inputs at: 2 put: (inputs at: 1).
	inputs at: 1 put: gain * sample.
	^ lastOutput := (inputs at: 1) + lastOutput! !

!LipFilter methodsFor: 'generation' stamp: 'len 9/3/2000 04:54'!
tick: mouthSample bore: boreSample
	| sample |
	sample := mouthSample - boreSample. "Differential pressure."
	sample := filter tick: sample. "Force -> position."
	sample := sample squared. "Simple position to area mapping."
	sample > 1.0 ifTrue: [sample := 1.0]. "Saturation at +1.0."
	lastOutput := sample * mouthSample. "Assume mouth input = area..."
	^ lastOutput := (1.0 - sample) * boreSample + lastOutput "...and Bore reflection is compliment."! !

!Envelope2 methodsFor: 'accessing' stamp: 'len 6/3/2000 20:40'!
time: aNumber
	self rate: 1.0 / aNumber / self samplingRate! !

!MonoWvIn methodsFor: 'generation-private' stamp: 'len 8/27/2000 02:03'!
updateTime
	"Update current time."
	time := time + rate.
	looping
		ifTrue: [[time >= length] whileTrue: [time := time - length].
				[time < 0.0] whileTrue: [time := time + length]]
		ifFalse: [time >= length ifTrue: [time := length - 1.0. finished := true].
				time < 0.0 ifTrue: [time := 0.0]]
! !

!ADSR methodsFor: 'accessing' stamp: 'len 5/28/2000 05:59'!
value: aNumber
	value := target := aNumber.
	state := self sustainState.
	self sustainLevel: aNumber.
	rate := 0.0! !

!Envelope2 methodsFor: 'accessing' stamp: 'len 5/28/2000 05:46'!
value: aNumber
	value := target := aNumber.
	state := 0! !

!BowedString methodsFor: 'accessing' stamp: 'len 5/29/2000 05:09'!
vibrato: amount
	vibrGain := amount! !

!BiQuad methodsFor: 'accessing' stamp: 'len 5/28/2000 03:38'!
zeroCoeffs: aCollection
	z0 := aCollection first.
	z1 := aCollection second! !
FM4Op initialize!
